Attribute VB_Name = "Module1"
Option Explicit

Public WebSites(0 To 41, 0 To 1) As String
Public EnableMousePicboxCursor As Boolean

'Public WifiCalculations As String   'from wifi form to add to textbox

Const SW_SHOW = 5

Private Const BIF_STATUSTEXT = &H4&
Private Const BIF_RETURNONLYFSDIRS = 1
Private Const BIF_DONTGOBELOWDOMAIN = 2
Private Const MAX_PATH = 260

Private Const WM_USER = &H400
Private Const BFFM_INITIALIZED = 1
Private Const BFFM_SELCHANGED = 2
Private Const BFFM_SETSTATUSTEXT = (WM_USER + 100)
Private Const BFFM_SETSELECTION = (WM_USER + 102)

Public Const pi = 3.14159265358979

Public Type PointType
    x As Double
    y As Double
End Type

Public ParabolaPoints As Single
Public P(1 To 3) As PointType
Public GraphPoints() As Double

Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As String) As Long
Private Declare Function SHBrowseForFolder Lib "shell32" (lpbi As BrowseInfo) As Long
Private Declare Function SHGetPathFromIDList Lib "shell32" (ByVal pidList As Long, ByVal lpBuffer As String) As Long
Private Declare Function lstrcat Lib "kernel32" Alias "lstrcatA" (ByVal lpString1 As String, ByVal lpString2 As String) As Long
Public Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hWnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long

Private Type BrowseInfo
  hWndOwner      As Long
  pIDLRoot       As Long
  pszDisplayName As Long
  lpszTitle      As Long
  ulFlags        As Long
  lpfnCallback   As Long
  lParam         As Long
  iImage         As Long
End Type

Public Reg                  As RegressionObject
Private m_CurrentDirectory  As String
Public InitDir              As String
Public Const CONFIG_FILE    As String = "configs.txt"
Public GraphFGColor         As Long
Public GraphBGColor         As Long
Public Depth                As Double
Public f_over_D             As Double

Public Sub SaveConfigs()
    On Error GoTo SaveConfigsErr
    Dim filename As String, filenum As Long
    filename = App.Path & "\" & CONFIG_FILE
    filenum = FreeFile
    Open filename For Output As #filenum
    Print #filenum, Str$(GraphFGColor)
    Print #filenum, Str$(GraphBGColor)
    Exit Sub
    '
SaveConfigsErr:
    MsgBox "Error in Sub SaveConfigs " & vbCrLf & "Error Number " & Err.Number & vbCrLf & "Error " & Err.Description
End Sub

Public Sub LoadConfigs()
    On Error GoTo LoadConfigsErr
    If Dir$(App.Path & "\" & CONFIG_FILE) = "" Then Exit Sub
    Dim fileinfo As String, filedata() As String
    fileinfo = FileIntoString(App.Path & "\" & CONFIG_FILE)
    filedata() = Split(fileinfo, vbCrLf)
    GraphFGColor = CLng(Trim$(filedata(0)))
    GraphBGColor = CLng(Trim$(filedata(1)))
    Exit Sub
    '
LoadConfigsErr:
    MsgBox "Error in Sub LoadConfigs " & vbCrLf & "Error Number " & Err.Number & vbCrLf & "Error " & Err.Description
End Sub

Public Function BrowseForFolder(owner As Form, Title As String, StartDir As String) As String
    'Handle "browser for folder dialog
    'Opens a Treeview control that displays the directories in a computer
    Dim lpIDList As Long, szTitle As String, sBuffer As String
    Dim tBrowseInfo As BrowseInfo
    m_CurrentDirectory = StartDir & vbNullChar
    szTitle = Title
    With tBrowseInfo
        .hWndOwner = owner.hWnd
        .lpszTitle = lstrcat(szTitle, "")
        .ulFlags = BIF_RETURNONLYFSDIRS + BIF_DONTGOBELOWDOMAIN + BIF_STATUSTEXT
        .lpfnCallback = GetAddressofFunction(AddressOf BrowseCallbackProc)  'get address of function.
    End With
    lpIDList = SHBrowseForFolder(tBrowseInfo)
    If (lpIDList) Then
        sBuffer = Space(MAX_PATH)
        SHGetPathFromIDList lpIDList, sBuffer
        sBuffer = Left(sBuffer, InStr(sBuffer, vbNullChar) - 1)
        BrowseForFolder = sBuffer
    Else
        BrowseForFolder = ""
    End If
End Function

Private Function BrowseCallbackProc(ByVal hWnd As Long, ByVal uMsg As Long, ByVal lp As Long, ByVal pData As Long) As Long
    Dim lpIDList As Long, ret As Long, sBuffer As String
    On Error Resume Next  'MS Sugested: prevent error from propagating back into calling process.
    Select Case uMsg
        Case BFFM_INITIALIZED
            Call SendMessage(hWnd, BFFM_SETSELECTION, 1, m_CurrentDirectory)
        Case BFFM_SELCHANGED
            sBuffer = Space(MAX_PATH)
            ret = SHGetPathFromIDList(lp, sBuffer)
            If ret = 1 Then Call SendMessage(hWnd, BFFM_SETSTATUSTEXT, 0, sBuffer)
    End Select
    BrowseCallbackProc = 0
End Function

Private Function GetAddressofFunction(add As Long) As Long
    ' This function allows you to assign a function pointer to a variable.
    GetAddressofFunction = add
End Function

Public Sub errhandler(location As String, errnumber As String, errdescription As String)
    MsgBox "There was an Error" & vbCrLf & vbCrLf & _
           "The Error was: Error Number " & errnumber & " : " & errdescription, vbOKOnly, "Error"
End Sub

Public Sub Navigate(ByVal NavTo As String)
    On Error GoTo NavigateErr
    Dim hBrowse As Long
    hBrowse = ShellExecute(0&, "open", NavTo, "", "", SW_SHOW)
    Exit Sub
    '
NavigateErr:
    errhandler "Navigate", Err.Number, Err.Description
End Sub

Public Sub LoadWebSites()
    On Error GoTo LoadWebSitesErr
    Dim n As Long
    'load websites into array
    '------------------------------------------------------------------------------
    'theory sites
    WebSites(0, 0) = "Parabola History and Examples"
    WebSites(1, 0) = "Parabola Math"
    WebSites(2, 0) = "Parabola Animation"
    WebSites(3, 0) = "Parabola Focal Point Math"
    WebSites(4, 0) = "Parabola Focal Point Animation"
    WebSites(5, 0) = "Parabola Math and Examples"
    WebSites(6, 0) = "Parabola History and Math"
    WebSites(37, 0) = "Purple Parabola Place"
    WebSites(38, 0) = "Parabolas"
    WebSites(39, 0) = "Parabolas in Life"
    WebSites(40, 0) = "Parabola Application"
    WebSites(41, 0) = "Why Are Satellite Dishes Parabolic?"
    '------------------------------------------------------------------------------
    WebSites(0, 1) = "http://acre.murdoch.edu.au/refiles/hightemp/"
    WebSites(1, 1) = "http://www-gap.dcs.st-and.ac.uk/~history/Curves/Parabola.html"
    WebSites(2, 1) = "http://www-gap.dcs.st-and.ac.uk/~history/Java/Parabola.html"
    WebSites(3, 1) = "http://mathworld.wolfram.com/Parabola.html"
    WebSites(4, 1) = "http://www.ies.co.jp/math/java/conics/focus/focus.html"
    WebSites(5, 1) = "http://www.xahlee.org/SpecialPlaneCurves_dir/Parabola_dir/parabola.html"
    WebSites(6, 1) = "http://www.2dcurves.com/conicsection/conicsectionp.html"
    WebSites(37, 1) = "http://mtl.math.uiuc.edu/users/M1Sallee/lesson.html"
    WebSites(38, 1) = "http://home.alltel.net/okrebs/page64.html"
    WebSites(39, 1) = "http://edservices.aea7.k12.ia.us/edtech/teacherpages/jmbrown/"
    WebSites(40, 1) = "http://www.np.edu.sg/mscIntMaths/PlnAnalGeom/4_Para.htm"
    WebSites(41, 1) = "http://mathcentral.uregina.ca/RR/database/RR.09.95/weston1.html"
    '==============================================================================
    'application web sites
    WebSites(7, 1) = "http://scitoys.com/scitoys/scitoys/light/solar_hotdog_cooker.html"
    WebSites(8, 1) = "http://www.cockeyed.com/incredible/parabola/parabola2.html"
    WebSites(9, 1) = "http://solarcooking.org/unattendedparabolic.htm"
    WebSites(10, 1) = "http://www.bali-i.com/solar/parabolic-prod.htm"
    WebSites(11, 1) = "http://www.acs.comcen.com.au/parabolic.html"
    WebSites(12, 1) = "http://home.arcor.de/Ernst.Willand/amsi-model.html"
    WebSites(13, 1) = "http://www.nrel.gov/education/pdfs/d_vinson.pdf"
    WebSites(14, 1) = "http://www.mueller-solartechnik.de/koch_eng.htm"
    WebSites(15, 1) = "http://home.arcor.de/Ernst.Willand/amsi-idea.html"
    WebSites(16, 1) = "http://solarcooking.org/parabolic-from-flat-sheet.htm"
    WebSites(17, 1) = "http://www.angelfire.com/ak/egel/kidheater.html"
    WebSites(18, 1) = "http://home.arcor.de/Ernst.Willand/amsi-conf.html"
    WebSites(19, 1) = "http://solarcooking.org/reflective-cooker-robustness.htm"
    WebSites(20, 1) = "http://solarcooking.org/plans.htm#parabolic-style"
    WebSites(21, 1) = "http://ashokk_3.tripod.com/solar1.htm"
    WebSites(22, 1) = "http://www.angelfire.com/80s/shobhapardeshi/ParvatiCooker.html"
    WebSites(23, 1) = "http://www.cc.jyu.fi/~hvirtane/cooker/"
    WebSites(24, 1) = "http://journeytoforever.org/sc_link.html"
    WebSites(25, 1) = "http://solarcooking.org/links.htm"
    WebSites(26, 1) = "http://www.mueller-solartechnik.com"
    '------------------------------------------------------------------------
    'review these sites
    WebSites(27, 1) = "http://www.grc.nasa.gov/WWW/K-12/Numbers/Math/Mathematical_Thinking/sun12.htm"
    WebSites(28, 1) = "http://ublib.buffalo.edu/libraries/e-resources/ebooks/records/751-1.html"
    WebSites(29, 1) = "http://icp.giss.nasa.gov/research/urbanmaap/aerosols_train6.html"
    WebSites(30, 1) = "http://www.zoo.ufl.edu/gpryor/biosphere.3.html"
    WebSites(31, 1) = "http://www.altenergy.org/2/renewables/solar/solar.html"
    WebSites(32, 1) = "http://almashriq.hiof.no/lebanon/600/610/614/solar-water/unesco/21-23.html"
    WebSites(33, 1) = "http://almashriq.hiof.no/lebanon/600/610/614/solar-water/unesco/24-26.html"
    WebSites(34, 1) = "http://rredc.nrel.gov/solar/"
    WebSites(35, 1) = "http://rredc.nrel.gov/solar/old_data/nsrdb/redbook/atlas/"
    WebSites(36, 1) = "http://www.ecoworld.org/Home/articles2.cfm?TID=288"
    '------------------------------------------------------------------------
    WebSites(7, 0) = "Cook hotdogs with the Sun in minutes."
    WebSites(8, 0) = "Home Parabola project using mirrors"
    WebSites(9, 0) = "A Parabolic Solar Cooker for Unattended Cooking"
    WebSites(10, 0) = "The Everest Parabolic Cooker"
    WebSites(11, 0) = "Parabolic Solar Collector Design Instructions"
    WebSites(12, 0) = "Parabola Design - Wood Model"
    WebSites(13, 0) = "Parabolic Troughs - Solar Hot Water Heaters"
    WebSites(14, 0) = "Examples of Available Solar Cooker Products"
    WebSites(15, 0) = "The Idea of Solar Cooking"
    WebSites(16, 0) = "Making a Parabolic Reflector Out of a Flat Sheet"
    WebSites(17, 0) = "Making a Parabolic Reflector from Trash"
    WebSites(18, 0) = "The Ninth International Conference on Solar Cooking"
    WebSites(19, 0) = "Reflective Solar Cooker Technical Discussion"
    WebSites(20, 0) = "Parabolic Cookers"
    WebSites(21, 0) = "Review of Solar Cooker Designs"
    WebSites(22, 0) = "How to make and use Parvati Solar Cooker "
    WebSites(23, 0) = "Designing and Building Home Made Focusing Solar Cookers"
    WebSites(24, 0) = "Solar Cooker Resources"
    WebSites(25, 0) = "Lots More Solar Links"
    WebSites(26, 0) = "Commercial Site Solar Cookers and Water Purification"
    '------------------------------------------------------------------------
    WebSites(27, 0) = "Calculating the Energy from Sunlight"
    WebSites(28, 0) = "Earth's Energy Balance"
    WebSites(29, 0) = "How Sunphotometers Determine Optical Depth"
    WebSites(30, 0) = "Biosphere Activated: Solar Power"
    WebSites(31, 0) = "Alternative Energy Institute, Inc."
    WebSites(32, 0) = "Solar Energy - From Sun to Earth"
    WebSites(33, 0) = "Solar Energy - World Distribution"
    WebSites(34, 0) = "Solar Radiation Resource Information"
    WebSites(35, 0) = "U.S. Solar Radiation Resource Maps"
    WebSites(36, 0) = "EcoWorld - Solar PV & Thermal Concentrators "
    '------------------------------------------------------------------------
    'load websites into labels
    For n = 0 To 41
        frmInput.lblParabolaSites(n).Caption = WebSites(n, 0)
        frmInput.lblParabolaSites(n).Font.Underline = True
        frmInput.lblParabolaSites(n).MousePointer = 99
    Next n
    'make html page of these links
    'MakeHTMLPage
   Exit Sub
   '
LoadWebSitesErr:
   errhandler "Sub LoadWebSites", Err.Number, Err.Description
   End Sub
   
Public Sub LoadURL(URL)
    On Error Resume Next
    Dim modobjie As Object
    Set modobjie = CreateObject("InternetExplorer.Application")
    modobjie.Visible = True
    modobjie.Navigate2 URL
    'modlngWndIE = modobjie.hwnd
    Set modobjie = Nothing
End Sub

Public Function CheckTextBoxEntries(ByVal keyascii)
    If IsNumeric(frmInput.txtDiameter.Text) And _
       IsNumeric(frmInput.txtDepth.Text) And _
       keyascii = 13 Then
            frmInput.btnCalculate.value = True
    End If
End Function

Private Sub MakeHTMLPage()
    Dim n As Long, filenum As Long, filename As String
    filename = "c:\temp\links.htm"
    filenum = FreeFile
    Open filename For Output As #filenum
        Print #filenum, "<html>" & vbCrLf & "<head>" & vbCrLf & "<title>Solar Links</title>" & vbCrLf & "</head>" & vbCrLf & vbCrLf & "<body>" & vbCrLf
        Print #filenum, "<h4 align=""" & "center" & """>Solar Links</h4>" & vbCrLf
        For n = LBound(WebSites, 1) To UBound(WebSites, 1)
            '<a href="http://www.google.com">Site Text</a>
            Print #filenum, "<a href=""" & WebSites(n, 1) & """>" & WebSites(n, 0) & "</a>" & vbCrLf
            Print #filenum, "<br><br>" & vbCrLf
        Next n
        Print #filenum, "</html>" & vbCrLf & "</body>"
    Close #filenum
End Sub

Public Function LinearDiameter(ByVal num As Single) As Double
    Dim i As Double, j As Long, n As Long, LinearDistance As Double, LinearDistanceTotal As Double
    Dim x1 As Double, x2 As Double, y1 As Double, y2 As Double, x As Double
    LinearDistance = 0
    LinearDistanceTotal = 0
    If num > 0 Then num = num * -1
    'if x = 0 lineardiameter = 0
    'special case, avoid precision error
    If num = 0 Then GoTo done
    For n = LBound(GraphPoints, 2) To UBound(GraphPoints, 2)
        'find current X point in array
        x = GraphPoints(1, n)
        If x = num Then
            'calculate distance from this x point to x = 0 point
            For j = n + 1 To UBound(GraphPoints, 2) \ 2 + 1
                x1 = GraphPoints(1, j - 1)
                x2 = GraphPoints(1, j)
                y1 = GraphPoints(2, j - 1)
                y2 = GraphPoints(2, j)
                LinearDistance = Sqr((x2 - x1) ^ 2 + (y2 - y1) ^ 2)
                LinearDistanceTotal = LinearDistanceTotal + LinearDistance
            Next j
            GoTo done
        End If
    Next n
done:
    LinearDiameter = LinearDistanceTotal
End Function

Public Sub SaveStreamFile()
    'save STREAM file for ACAD
    On Error GoTo SaveStreamFileErr
    Dim folder As String, filename, filenum As Long, defaultfilename As String, n As Long
    'build filename to make file specific using diam & depth
    defaultfilename = "Parabola Diameter " & frmInput.txtDiameter.Text & " Depth " & frmInput.txtDepth.Text & ".stm"
    'let user browser for output folder
    folder = BrowseForFolder(frmInput, "Select the Folder for the File", InitDir)
    If Len(folder) = 0 Then Exit Sub
    'remember selected folder, open dialog in that folder next time.
    InitDir = folder
    'prompt user to accept or enter a new filename
    filename = InputBox("Please Enter the STREAM Filename (ending with "".stm"")", "Filename", defaultfilename)
    If Len(filename) = 0 Then Exit Sub
    'save data to file
    filenum = FreeFile
    If Not Right(folder, 1) = "\" Then folder = folder & "\"
    If Not Right(LCase$(filename), 4) = ".stm" Then filename = filename & ".stm"
    Open folder & filename For Output As #filenum
        Print #filenum, "STREAM"
        For n = LBound(GraphPoints, 2) To UBound(GraphPoints, 2)
            Print #filenum, GraphPoints(1, n) & " " & GraphPoints(2, n)  'x point   'y point
        Next n
    Close #filenum
    DoEvents
    MsgBox "The Parabola Data was saved to " & vbCrLf & folder & filename, vbOKOnly
    OpenFileInNotepad (folder & filename)
    Exit Sub
    '
SaveStreamFileErr:
    Close #filenum
    errhandler "SaveStreamFile", Err.Number, Err.Description
End Sub

Public Sub SaveInputValues()
    'save depth, diameter and segments to text File
    On Error GoTo SaveInputValuesErr
    Dim folder As String, filename, filenum As Long, defaultfilename As String, n As Long
    'build filename to make file specific using diam & depth
    defaultfilename = "Parabola_Inputs_D_" & frmInput.txtDiameter.Text & "_d_" & frmInput.txtDepth.Text & "_S_" & frmInput.txtPoints.Text & ".txt"
    'let user browser for output folder
    folder = BrowseForFolder(frmInput, "Select the Folder for the File", InitDir)
    If Len(folder) = 0 Then Exit Sub
    'remember selected folder, open dialog in that folder next time.
    InitDir = folder
    'prompt user to accept or enter a new filename
    filename = InputBox("Please Enter the Filename (ending with "".txt"")", "Filename", defaultfilename)
    If Len(filename) = 0 Then Exit Sub
    'save data to file
    filenum = FreeFile
    If Not Right(folder, 1) = "\" Then folder = folder & "\"
    If Not Right(LCase$(filename), 4) = ".txt" Then filename = filename & ".txt"
    Open folder & filename For Output As #filenum
        Print #filenum, "Diameter" & vbTab & Trim$(frmInput.txtDiameter.Text)
        Print #filenum, "depth" & vbTab & Trim$(frmInput.txtDepth.Text)
        Print #filenum, "Segments" & vbTab & Trim$(frmInput.txtPoints.Text)
    Close #filenum
    DoEvents
    MsgBox "The Parabola Data was saved to " & vbCrLf & folder & filename, vbOKOnly
    Exit Sub
    '
SaveInputValuesErr:
    Close #filenum
    errhandler "SaveInputValues", Err.Number, Err.Description
End Sub

Public Sub LoadInputValues()
    On Error GoTo LoadInputValuesErr
    'load depth, diameter and segments from text File
    Dim sFilters As String, buff As String, sLongname As String, sShortname As String
    Dim pos As Long, filedata As String, filevalues() As String, linevalue() As String
    '-----------------------------------------------------------------------------
    'create a string of filters for the dialog
    sFilters = "Text Files" & vbNullChar & "*.txt" & vbNullChar ' & "All Files" & vbNullChar & "*.*" & vbNullChar & vbNullChar
    '-----------------------------------------------------------------------------
    With OFN
        'size of the OFN structure
        .nStructSize = Len(OFN)
        'window owning the dialog
        .hWndOwner = frmInput.hWnd
        'filters (patterns) for the dropdown combo
        .sFilter = sFilters
        'index to the initial filter
        .nFilterIndex = 2
        'default filename, plus additional padding for the user's final
        'selection(s). Must be double-null terminated
        .sFile = "" & Space$(1024) & vbNullChar & vbNullChar
        'the size of the buffer
        .nMaxFile = Len(.sFile)
        'default extension applied to file if it has no extention
        .sDefFileExt = "bas" & vbNullChar & vbNullChar
        'space for the file title if a single selection
        'made, double-null terminated, and its size
        .sFileTitle = vbNullChar & Space$(512) & vbNullChar & vbNullChar
        .nMaxTitle = Len(OFN.sFileTitle)
        'starting folder, double-null terminated
        .sInitialDir = App.Path & vbNullChar & vbNullChar
        'the dialog title
        .sDialogTitle = "Select Keyword Text File"
        'default open flags and multiselect
        .flags = OFS_FILE_OPEN_FLAGS 'Or OFN_ALLOWMULTISELECT
    End With
    'call the API
    If GetOpenFileName(OFN) Then
        'remove trailing pair of terminating nulls and trim returned file string
        buff = Trim$(Left$(OFN.sFile, Len(OFN.sFile) - 2))
        filedata = FileIntoString(OFN.sFile)
        filevalues = Split(filedata, vbCrLf)
        linevalue = Split(filevalues(0), vbTab)
        frmInput.txtDiameter.Text = linevalue(1)
        linevalue = Split(filevalues(1), vbTab)
        frmInput.txtDepth.Text = linevalue(1)
        linevalue = Split(filevalues(2), vbTab)
        frmInput.txtPoints.Text = linevalue(1)
        frmInput.btnCalculate.value = True
        DoEvents
    Else
        MsgBox "There was a problem reading the file", vbCritical, "Please Make Sure the File Exists"
    End If
    Exit Sub
    '
LoadInputValuesErr:
    errhandler "LoadInputValues", Err.Number, Err.Description
End Sub

Public Sub SaveExcelTextFile()
    'save Excel Tab Delimited Text File
    On Error GoTo SaveExcelTextFileErr
    Dim folder As String, filename, filenum As Long, defaultfilename As String, n As Long
    'build filename to make file specific using diam & depth
    defaultfilename = "Parabola Diameter " & frmInput.txtDiameter.Text & " Depth " & frmInput.txtDepth.Text & ".txt"
    'let user browser for output folder
    folder = BrowseForFolder(frmInput, "Select the Folder for the File", InitDir)
    If Len(folder) = 0 Then Exit Sub
    'remember selected folder, open dialog in that folder next time.
    InitDir = folder
    'prompt user to accept or enter a new filename
    filename = InputBox("Please Enter the Excel Text Filename (ending with "".txt"")", "Filename", defaultfilename)
    If Len(filename) = 0 Then Exit Sub
    'save data to file
    filenum = FreeFile
    If Not Right(folder, 1) = "\" Then folder = folder & "\"
    If Not Right(LCase$(filename), 4) = ".txt" Then filename = filename & ".txt"
    Open folder & filename For Output As #filenum
        For n = LBound(GraphPoints, 2) To UBound(GraphPoints, 2)
            Print #filenum, GraphPoints(1, n) & vbTab & GraphPoints(2, n)  'x point   'y point
        Next n
    Close #filenum
    DoEvents
    MsgBox "The Parabola Data was saved to " & vbCrLf & folder & filename, vbOKOnly
    Exit Sub
    '
SaveExcelTextFileErr:
    Close #filenum
    errhandler "SaveExcelTextFile", Err.Number, Err.Description
End Sub

Public Sub SaveTextFile()
    On Error GoTo SaveTextFileErr
    Dim folder As String, filename, filenum As Long, defaultfilename As String, vbAns As Long
    'build filename to make file specific using diam & depth
    defaultfilename = "Parabola Diameter " & frmInput.txtDiameter.Text & " Depth " & frmInput.txtDepth.Text & ".txt"
    'let user browser for output folder
    folder = BrowseForFolder(frmInput, "Select the Folder for the File", InitDir)
    If Len(folder) = 0 Then Exit Sub
    'remember selected folder, open dialog in that folder next time.
    InitDir = folder
    'prompt user to accept or enter a new filename
    filename = InputBox("Please Enter the Filename (ending with "".txt"")", "Filename", defaultfilename)
    If Len(filename) = 0 Then Exit Sub
    'save data to file
    filenum = FreeFile
    If Not Right(folder, 1) = "\" Then folder = folder & "\"
    If Not Right(UCase$(filename), 4) = ".TXT" Then filename = filename & ".txt"
    Open folder & filename For Output As #filenum
        Print #filenum, frmInput.Text1.Text
        'If WifiCalculations <> "" Then Print #filenum, vbCrLf & WifiCalculations
    Close #filenum
    DoEvents
    vbAns = MsgBox("The Parabola Data was saved to " & vbCrLf & folder & filename, vbYesNo, "View Saved File?")
    If vbAns = vbYes Then OpenFileInNotepad (folder & filename)
    Exit Sub
    '
SaveTextFileErr:
    Close #filenum
    errhandler "SaveTextFile", Err.Number, Err.Description
End Sub

Public Sub SaveWifiTextFile(data As String)
    On Error GoTo SaveWifiTextFileErr
    Dim folder As String, filename, filenum As Long, defaultfilename As String, units As String, vbAns As Long
    'get units from wifi form
    If frmWifiCentered.optUnits(0).value = True Then
        units = "mm."
    Else
        units = "in."
    End If
    'build filename to make file specific using diam & depth
    If frmInput.mnuOptionsInputsDiameterDepth.Checked = True Then
        'inputs are diameter and depth
        defaultfilename = "Parabola Freq " & frmWifiCentered.txtFreq.Text & " Diam " & frmWifiCentered.txtDiameter.Text & " Depth " & frmWifiCentered.txtDepth.Text & ".txt"
    Else
        'inputs are diameter and f/D
        defaultfilename = "Parabola Freq " & frmWifiCentered.txtFreq.Text & " Diam " & frmWifiCentered.txtDiameter.Text & " f_over_D " & frmWifiCentered.txtDepth.Text & ".txt"
    End If
    'let user browser for output folder
    folder = BrowseForFolder(frmInput, "Select the Folder for the File", InitDir)
    If Len(folder) = 0 Then Exit Sub
    'remember selected folder, open dialog in that folder next time.
    InitDir = folder
    'prompt user to accept or enter a new filename
    filename = InputBox("Please Enter the Filename (ending with "".txt"")", "Filename", defaultfilename)
    If Len(filename) = 0 Then Exit Sub
    'save data to file
    filenum = FreeFile
    If Not Right(folder, 1) = "\" Then folder = folder & "\"
    If Not Right(UCase$(filename), 4) = ".TXT" Then filename = filename & ".txt"
    Open folder & filename For Output As #filenum
        Print #filenum, "Frequency" & vbTab & frmWifiCentered.txtFreq.Text & " MHz"
        Print #filenum, "Diameter " & vbTab & frmWifiCentered.txtDiameter.Text & " " & units
        Print #filenum, "Depth    " & vbTab & Format$(Depth, "0.00") & " " & units
        Print #filenum, "f/D      " & vbTab & f_over_D
        Print #filenum, String$(25, "-")
        Print #filenum, data
    Close #filenum
    vbAns = MsgBox("The Parabola Data was saved to " & vbCrLf & folder & filename, vbYesNo, "View Saved File?")
    If vbAns = vbYes Then OpenFileInNotepad (folder & filename)
    OpenFileInNotepad (folder & filename)
    Exit Sub
    '
SaveWifiTextFileErr:
    Close #filenum
    errhandler "SaveWifiTextFile", Err.Number, Err.Description
End Sub

Public Sub SaveWifiOffsetTextFile(data As String)
    On Error GoTo SaveWifiOffsetTextFileErr
    Dim folder As String, filename, filenum As Long, defaultfilename As String, units As String, vbAns As Long
    '-------------------------
    'get units from wifi form
    '-------------------------
    If frmWifiOffset.optUnits(0).value = True Then
        units = "in."
    Else
        units = "mm."
    End If
    '-------------------------
    'build filename w/freq, diam & depth
    '-------------------------
    defaultfilename = "Parabola Offset Freq " & frmWifiOffset.txtFreq.Text & _
                                     " LgDiam " & frmWifiOffset.txtLargeDiameter.Text & _
                                     " SmDiam " & frmWifiOffset.txtSmallDiameter.Text & _
                                     " Depth " & frmWifiOffset.txtDepth.Text & ".txt"
    '-------------------------
    'let user select output folder
    '-------------------------
    folder = BrowseForFolder(frmInput, "Select the Folder for the File", InitDir)
    If Len(folder) = 0 Then Exit Sub
    InitDir = folder 'remember selected folder, open dialog in that folder next time.
    '-------------------------
    'prompt user to accept or enter a new filename
    '-------------------------
    filename = InputBox("Please Enter the Filename (ending with "".txt"")", "Filename", defaultfilename)
    If Len(filename) = 0 Then Exit Sub
    '-------------------------
    'save data to file
    '-------------------------
    filenum = FreeFile
    If Not Right(folder, 1) = "\" Then folder = folder & "\"
    If Not Right(UCase$(filename), 4) = ".TXT" Then filename = filename & ".txt"
    Open folder & filename For Output As #filenum
        Print #filenum, "Frequency      " & vbTab & frmWifiOffset.txtFreq.Text & " MHz"
        Print #filenum, "Large Diameter " & vbTab & frmWifiOffset.txtLargeDiameter.Text & " " & units
        Print #filenum, "Small Diameter " & vbTab & frmWifiOffset.txtSmallDiameter.Text & " " & units
        Print #filenum, "Depth          " & vbTab & frmWifiOffset.txtDepth.Text & " " & units
        Print #filenum, "Distance of deepest point from bottom edge along large axis" & vbTab & frmWifiOffset.txtOdepthPosition.Text & " " & units
        Print #filenum, String$(25, "-")
        Print #filenum, data
    Close #filenum
    vbAns = MsgBox("The Parabola Data was saved to " & vbCrLf & folder & filename, vbYesNo, "View Saved File?")
    If vbAns = vbYes Then OpenFileInNotepad (folder & filename)
    OpenFileInNotepad (folder & filename)
    Exit Sub
    '
SaveWifiOffsetTextFileErr:
    errhandler "Sub SaveWifiOffsetTextFile", Err.Number, Err.Description
End Sub

Public Sub LoadDataIntoExcel()
    On Error GoTo LoadDataIntoExcelErr
    'see if Excel is installed on local machine
    If Not ExcelInstalled Then
        '===========================================================================
        'Excel Is Not Installed
        MsgBox "Excel is not installed on this computer." & vbCrLf & vbCrLf & _
               "This function will not work without a valid Microsoft Excel Installation.", vbOKOnly, "Excel Not Installed"
    Else
        '===========================================================================
        'Excel Is Installed
        '-----------------------------------------------
        Dim objXL           As New Excel.Application
        Dim wbXL            As New Excel.Workbook
        Dim wsXL            As New Excel.Worksheet
        Dim n               As Long
        '------------------------------------------------
        'if user doesn't have Excel installed, exit
        If Not IsObject(objXL) Then
            'okay to show msgbox, this menu choice clicked manually
            MsgBox "You need Microsoft Excel to use this function", vbExclamation, "Print to Excel"
            Exit Sub
        End If
        DoEvents
        '------------------------------------------------
    'save data to file
        'open Excel
        objXL.Visible = True
        Set wbXL = objXL.Workbooks.add
        Sleep 100
        DoEvents
        Set wsXL = objXL.ActiveSheet
        Sleep 100
        DoEvents
        '------------------------------------------------
        'name worksheet
        wsXL.Name = "Parabola Diameter " & frmInput.txtDiameter.Text & " Depth " & frmInput.txtDepth.Text
        Sleep 100
        DoEvents
        '------------------------------------------------
        'fill worksheet with data
        For n = LBound(GraphPoints, 2) To UBound(GraphPoints, 2)
            wsXL.Cells(n, 1).value = GraphPoints(1, n)
            wsXL.Cells(n, 2).value = GraphPoints(2, n)
            DoEvents
        Next
        Sleep 100
        DoEvents
        '------------------------------------------------
        'format the look
        For n = 1 To UBound(GraphPoints, 2)
            wsXL.Columns(n).AutoFit
            'wsXL.Range("a1", Right(wsXL.Columns(frmMain.MSFlexGrid1.Cols).AddressLocal, 1) & MSFlexGrid1.Rows).AutoFormat 3   'GridStyle 2,3 is good
            DoEvents
        Next
        Sleep 100
        DoEvents
    End If
    Exit Sub
    '
LoadDataIntoExcelErr:
    errhandler "Sub LoadDataIntoExcel", Err.Number, Err.Description
End Sub

Public Sub SaveTabularFile()
    'save TABULAR file for ACAD
    On Error GoTo SaveTextFileErr
    Dim folder As String, filename, filenum As Long, defaultfilename As String, n As Long
    'build filename to make file specific using diam & depth
    defaultfilename = "Parabola Diameter " & frmInput.txtDiameter.Text & " Depth " & frmInput.txtDepth.Text & "_acad.txt"
    'let user browser for output folder
    folder = BrowseForFolder(frmInput, "Select the Folder for the File", InitDir)
    If Len(folder) = 0 Then Exit Sub
    'remember selected folder, open dialog in that folder next time.
    InitDir = folder
    'prompt user to accept or enter a new filename
    filename = InputBox("Please Enter the Filename (ending with ""_acad.txt"")", "Filename", defaultfilename)
    If Len(filename) = 0 Then Exit Sub
    'save data to file
    filenum = FreeFile
    If Not Right(folder, 1) = "\" Then folder = folder & "\"
    If Not Right(LCase$(filename), 9) = "_acad.txt" Then filename = filename & "_acad.txt"
    Open folder & filename For Output As #filenum
        Print #filenum, "Parabola Diameter " & frmInput.txtDiameter.Text & " Depth " & frmInput.txtDepth.Text
        For n = LBound(GraphPoints, 2) To UBound(GraphPoints, 2)
            Print #filenum, n & " " & GraphPoints(1, n) & " " & GraphPoints(2, n)  'id xpoint 'ypoint
        Next n
    Close #filenum
    DoEvents
    MsgBox "The Parabola Data was saved to " & vbCrLf & folder & filename, vbOKOnly
    OpenFileInNotepad (folder & filename)
    Exit Sub
    '
SaveTextFileErr:
    Close #filenum
    errhandler "SaveTextFile", Err.Number, Err.Description
End Sub

Public Sub SaveHPGLFile()
    On Error GoTo SaveHPGLFileErr
    Const HPGL_Extension As String = ".hpg"
    '=============================================================================
    'NOTES: VERSION I
    '    LEGEND: Ec = [Ctrl] [P] [Esc] in DOS EDIT
    '    EcE Resets the printer.
    '    Ec%0B   Enters HP-GL/2 mode.
    '    IN; Initializes HP-GL/2 mode.
    '    SP1;    Selects pen number 1 (black).
    '        Even though there is no physical pen, the SP command must be used to enable printing.
    '    PA1000,100;PD2500,100;  Specifies (1000,100) as the starting location, places the pen down,
    '        and draws a line to (2500,100).
    '    PU650,1150;PD1000,1150; Lifts the pen up and moves to (650,1150),
    '        then places the pen down and draws a line to (1000,1150).
    '    PU650,450;PD1000,450;   Lifts the pen up and moves to (650,450) then places
    '        the pen down, and draws a line to (1000,450).
    '    PU1000,100;PD1000,1500,2500,1500;   Lifts the pen up and moves to (1000,100), then places
    '        the pen down and draws a line to (1000,1500), then draws a line to (2500,1500).
    '    PU3200,900;PD;  Lifts the pen and moves it to (3200,900), and sets the pen down.
    '    Ec%0A;  Enters PCL mode.
    '    EcE Sends a reset to end the job and eject the page.
    '=============================================================================
    'NOTES: VERSION II
    '    EcE Resets the printer.
    '    Ec%0B   Enters HP-GL/2 mode.
    '    IN; Initializes HP-GL/2 mode.
    '    SP1;    Selects pen #1 (black). The SP command must be used to enable printing.
    '    PA1000,100;PD2500,100;  Spec (1000,100) as start pt, place pen down, draw line to (2500,100)
    '=============================================================================
    Dim folder As String, filename, filenum As Long, defaultfilename As String, n As Long, j As Long
    'build filename to make file specific using diam & depth
    defaultfilename = "Parabola Diameter " & frmInput.txtDiameter.Text & " Depth " & frmInput.txtDepth.Text & HPGL_Extension
    'let user browser for output folder
    folder = BrowseForFolder(frmInput, "Select the Folder for the File", InitDir)
    If Len(folder) = 0 Then Exit Sub
    'remember selected folder, open dialog in that folder next time.
    InitDir = folder
    'prompt user to accept or enter a new filename
    filename = InputBox("Please Enter the Filename (ending with """ & HPGL_Extension & """)", "Filename", defaultfilename)
    If Len(filename) = 0 Then Exit Sub
    'save data to file
    filenum = FreeFile
    If Not Right(folder, 1) = "\" Then folder = folder & "\"
    'insure correct extension
    If Not Right(LCase$(filename), 4) = HPGL_Extension Then filename = filename & HPGL_Extension
    'get index of 1st data point for PA line
    j = LBound(GraphPoints, 2)
    Open folder & filename For Output As #filenum
        Print #filenum, "EcE"
        Print #filenum, "Ec&0B"
        Print #filenum, "IN;"
        Print #filenum, "SP1;"
        Print #filenum, "PA" & GraphPoints(1, j) & "," & GraphPoints(2, j) & ";PD" & GraphPoints(1, j + 1) & "," & GraphPoints(2, j + 1)
        For n = LBound(GraphPoints, 2) + 3 To UBound(GraphPoints, 2)
            Print #filenum, "PD" & GraphPoints(1, n) & "," & GraphPoints(2, n)   'draw line to (Xn,Yn)
        Next n
        Print #filenum, "Ec%0A;"
        Print #filenum, "EcE"
    Close #filenum
    DoEvents
    MsgBox "The Parabola Data was saved to " & vbCrLf & folder & filename, vbOKOnly
    OpenFileInNotepad (folder & filename)
    Exit Sub
    '
SaveHPGLFileErr:
    Close #filenum
    errhandler "SaveHPGLFile", Err.Number, Err.Description
End Sub

Public Sub SaveCorelDrawFile()
    On Error GoTo SaveCorelDrawFileErr
    Const CorelDraw_Extension As String = ".plt"
    '=============================================================================
    'NOTES: VERSION GAGA
    '    IN;
    '    SP1;
    '    LT;
    '    PU-25.00 15.00;
    '    PD-22.50 12.15;
    '    ...
    '    PD22.50 12.15;
    '    PD25.00 15.00;
    '    SP20;
    '=============================================================================
    Dim folder As String, filename, filenum As Long, defaultfilename As String, n As Long, j As Long
    'build filename to make file specific using diam & depth
    defaultfilename = "Parabola Diameter " & frmInput.txtDiameter.Text & " Depth " & frmInput.txtDepth.Text & CorelDraw_Extension
    'let user browser for output folder
    folder = BrowseForFolder(frmInput, "Select the Folder for the File", InitDir)
    If Len(folder) = 0 Then Exit Sub
    'remember selected folder, open dialog in that folder next time.
    InitDir = folder
    'prompt user to accept or enter a new filename
    filename = InputBox("Please Enter the Filename (ending with """ & CorelDraw_Extension & """)", "Filename", defaultfilename)
    If Len(filename) = 0 Then Exit Sub
    'save data to file
    filenum = FreeFile
    If Not Right(folder, 1) = "\" Then folder = folder & "\"
    'insure correct extension
    If Not Right(LCase$(filename), 4) = CorelDraw_Extension Then filename = filename & CorelDraw_Extension
    'get index of 1st data point for PA line
    j = LBound(GraphPoints, 2)
    Open folder & filename For Output As #filenum
        Print #filenum, "IN;"
        Print #filenum, "SP1;"
        Print #filenum, "LT;"
        'pick up pen and move it to the leftmost point
        Print #filenum, "PU" & Format(GraphPoints(1, j), "0.00") & " " & Format(GraphPoints(2, j), "0.00") & ";"
        'now draw lines to each of the rest of the points
        For n = LBound(GraphPoints, 2) + 1 To UBound(GraphPoints, 2)
            Print #filenum, "PD" & Format(GraphPoints(1, n), "0.00") & " " & Format(GraphPoints(2, n), "0.00") & ";"      'draw line to (Xn,Yn)
        Next n
        'move to the focal point
        Print #filenum, "PU0 " & frmInput.lblFocalLength.Caption & ";"
        Print #filenum, "CI0.2"
    Close #filenum
    DoEvents
    MsgBox "The Parabola Data was saved to " & vbCrLf & folder & filename, vbOKOnly
    OpenFileInNotepad (folder & filename)
    Exit Sub
    '
SaveCorelDrawFileErr:
    Close #filenum
    errhandler "SaveCorelDrawFile", Err.Number, Err.Description
End Sub

Public Sub SaveDXFFile()
    On Error GoTo SaveDXFFileErr
    Const DXF_Extension As String = ".dxf"
    '=============================================================================
    'Rem Simple DXF Header
    '        Open "Data.DXF" For Output As HFILE         'DXF FILE.
    '        Print #filenum, "  0"
    '        Print #filenum, "SECTION"
    '        Print #filenum, "  2"
    '        Print #filenum, "ENTITIES"
    'Rem Body
    '
    'LineCounter = 48
    '
    'For lLineCount = 1 To lNumberOfLines
    '            Print #filenum, "  0"
    '            Print #filenum, "LINE"
    '            Print #filenum, "  5"
    '            Print #filenum, Hex$(LineCounter)
    '            Print #filenum, "100"
    '            Print #filenum, "AcDbEntity"
    '            Print #filenum, "  8"
    '            Print #filenum, "0"
    '            Print #filenum, " 62"                ' Line Color Format
    '            Print #filenum, "     " + Str$(45)   ' Line Color
    '            Print #filenum, "100"
    '            Print #filenum, "AcDbLine"
    '            Print #filenum, " 10"
    '            Print #filenum, TypOld.X
    '            Print #filenum, " 20"
    '            Print #filenum, TypOld.Y
    '            Print #filenum, " 30"
    '            Print #filenum, TypOld.Z
    '            Print #filenum, " 11"
    '            Print #filenum, TypNew.X
    '            Print #filenum, " 21"
    '            Print #filenum, TypNew.Y
    '            Print #filenum, " 31"
    '            Print #filenum, TypNew.Z
    '            INCR LineCounter    '
    'Rem Save the old data values for new loop
    '            TypOld.X = TypNew.X
    '            TypOld.Y = TypNew.Y
    '            TypOld.Z = TypNew.Z
    '        Next lLineCount
    '
    'Rem footer
    '        Print #filenum, "  0"
    '        Print #filenum, "ENDSEC"
    '        Print #filenum, "  0"
    '        Print #filenum, "EOF"
    '        Close HFILE
    '=============================================================================
    Dim folder As String, filename, filenum As Long, defaultfilename As String, n As Long
    'build filename to make file specific using diam & depth
    defaultfilename = "Parabola Diameter " & frmInput.txtDiameter.Text & " Depth " & frmInput.txtDepth.Text & DXF_Extension
    'let user browse for output folder
    folder = BrowseForFolder(frmInput, "Select the Folder for the File", InitDir)
    If Len(folder) = 0 Then Exit Sub
    'remember selected folder, open dialog in that folder next time.
    InitDir = folder
    'prompt user to accept or enter a new filename
    filename = InputBox("Please Enter the Filename (ending with """ & DXF_Extension & """)", "Filename", defaultfilename)
    If Len(filename) = 0 Then Exit Sub
    'save data to file
    filenum = FreeFile
    If Not Right(folder, 1) = "\" Then folder = folder & "\"
    'insure correct extension
    If Not Right(LCase$(filename), 4) = DXF_Extension Then filename = filename & DXF_Extension
    Open folder & filename For Output As #filenum
        '--------------------------
        ' header
        '--------------------------
        Print #filenum, "999"
        Print #filenum, "This DXF saved by the Parabola Calculator program"
        Print #filenum, "  0"
        Print #filenum, "SECTION"
        Print #filenum, "  2"
        Print #filenum, "ENTITIES"
        '--------------------------
        ' code to draw each line
        '--------------------------
        For n = LBound(GraphPoints, 2) To UBound(GraphPoints, 2) - 1
            'Print #filenum, "PD" & Format(GraphPoints(1, n), "0.00") & " " & Format(GraphPoints(2, n), "0.00") & ";"      'draw line to (Xn,Yn)
            Print #filenum, "  0"
            Print #filenum, "LINE"
            Print #filenum, "  5"
            Print #filenum, Hex$(n)
            Print #filenum, "100"
            Print #filenum, "AcDbEntity"
            Print #filenum, "  8"
            Print #filenum, "0"
            Print #filenum, " 62"                   ' Line Color Format
            'Print #filenum, "     " + Str$(45)     ' Line Color
            Print #filenum, "    255"               '" + Str$(45)   ' Line Color
            Print #filenum, "100"
            Print #filenum, "AcDbLine"
            Print #filenum, " 10"
            Print #filenum, GraphPoints(1, n)       'TypOld.X
            Print #filenum, " 20"
            Print #filenum, GraphPoints(2, n)       'TypOld.Y
            Print #filenum, " 30"
            Print #filenum, 0#                      'TypOld.Z
            Print #filenum, " 11"
            Print #filenum, GraphPoints(1, n + 1)   'TypNew.X
            Print #filenum, " 21"
            Print #filenum, GraphPoints(2, n + 1)   'TypNew.Y
            Print #filenum, " 31"
            Print #filenum, 0#                      'TypNew.Z
        Next n
        '--------------------------
        ' footer
        '--------------------------
        Print #filenum, "  0"
        Print #filenum, "ENDSEC"
        Print #filenum, "  0"
        Print #filenum, "EOF"
    Close #filenum
    DoEvents
    MsgBox "The Parabola Data was saved to " & vbCrLf & folder & filename, vbOKOnly
    OpenFileInNotepad (folder & filename)
    Exit Sub
    '
SaveDXFFileErr:
    Close #filenum
    errhandler "SaveDXFFile", Err.Number, Err.Description
End Sub

Public Sub SaveDXFFile2()
    On Error GoTo SaveDXFFile2Err
    Const DXF_Extension As String = ".dxf"
    Dim folder As String, filename, filenum As Long, defaultfilename As String, n As Long
    Dim x1 As Long, y1 As Long, z1 As Long
    Dim x2 As Long, y2 As Long, y3 As Long
    'build filename to make file specific using diam & depth
    defaultfilename = "Parabola Diameter " & frmInput.txtDiameter.Text & " Depth " & frmInput.txtDepth.Text & DXF_Extension
    'let user browse for output folder
    folder = BrowseForFolder(frmInput, "Select the Folder for the File", InitDir)
    If Len(folder) = 0 Then Exit Sub
    'remember selected folder, open dialog in that folder next time.
    InitDir = folder
    'prompt user to accept or enter a new filename
    filename = InputBox("Please Enter the Filename (ending with """ & DXF_Extension & """)", "Filename", defaultfilename)
    If Len(filename) = 0 Then Exit Sub
    'save data to file
    filenum = FreeFile
    If Not Right(folder, 1) = "\" Then folder = folder & "\"
    'insure correct extension
    If Not Right(LCase$(filename), 4) = DXF_Extension Then filename = filename & DXF_Extension
    '=============================================================================
    'Simple DXF Header
    '------------------------
    'Open "Data.DXF" For Output As #filenum
    'Print #filenum, "  0"
    'Print #filenum, "SECTION"
    'Print #filenum, "  2"
    'Print #filenum, "ENTITIES"
    'Rem Body
    '------------------------
    'data points polyline
    '------------------------
    '10 start x1
    '20 start y1
    '30 start z1
    '11 end x2
    '21 end y2
    '31 end z2
    '
    '12 start x2
    '22 start y2
    '32 start z2
    '13 end x3
    '23 end y3
    '33 end z3
    '------------------------
    'footer
    '------------------------
    'Print #filenum, "  0"
    'Print #filenum, "ENDSEC"
    'Print #filenum, "  0"
    'Print #filenum, "EOF"
    'Close HFILE
    '=============================================================================
    Open folder & filename For Output As #filenum
        '--------------------------
        ' header
        '--------------------------
        Print #filenum, "999"
        Print #filenum, "Saved by the Parabola Calculator program"
        Print #filenum, "  0"
        Print #filenum, "SECTION"
        Print #filenum, "  2"
        Print #filenum, "ENTITIES"
        '--------------------------
        ' code to draw each line
        '--------------------------
        For n = LBound(GraphPoints, 2) To UBound(GraphPoints, 2) - 1
            'Print #filenum, "PD" & Format(GraphPoints(1, n), "0.00") & " " & Format(GraphPoints(2, n), "0.00") & ";"      'draw line to (Xn,Yn)
            Print #filenum, "  0"
            Print #filenum, "LINE"
            Print #filenum, "  5"
            Print #filenum, Hex$(n)
            Print #filenum, "100"
            Print #filenum, "AcDbEntity"
            Print #filenum, "  8"
            Print #filenum, "0"
            Print #filenum, " 62"                   ' Line Color Format
            'Print #filenum, "     " + Str$(45)     ' Line Color
            Print #filenum, "    255"               '" + Str$(45)   ' Line Color
            Print #filenum, "100"
            Print #filenum, "AcDbLine"
            Print #filenum, " 10"
            Print #filenum, GraphPoints(1, n)       'TypOld.X
            Print #filenum, " 20"
            Print #filenum, GraphPoints(2, n)       'TypOld.Y
            Print #filenum, " 30"
            Print #filenum, 0#                      'TypOld.Z
            Print #filenum, " 11"
            Print #filenum, GraphPoints(1, n + 1)   'TypNew.X
            Print #filenum, " 21"
            Print #filenum, GraphPoints(2, n + 1)   'TypNew.Y
            Print #filenum, " 31"
            Print #filenum, 0#                      'TypNew.Z
        Next n
        '--------------------------
        ' footer
        '--------------------------
        Print #filenum, "  0"
        Print #filenum, "ENDSEC"
        Print #filenum, "  0"
        Print #filenum, "EOF"
    Close #filenum
    DoEvents
    MsgBox "The Parabola Data was saved to " & vbCrLf & folder & filename, vbOKOnly
    OpenFileInNotepad (folder & filename)
    Exit Sub
    '
SaveDXFFile2Err:
    Close #filenum
    errhandler "SaveDXFFile2", Err.Number, Err.Description
End Sub

Public Sub OpenFileInNotepad(filename As String)
    On Error Resume Next
    'open text file in default text file editor
    'Shell "notepad.exe " & filename, vbNormalFocus
    'ShellExecute frmInput.hwnd, "Open", vbNullString, filename, vbNullString, vbNormalFocus
    ShellExecute frmInput.hWnd, "open", filename, vbNullString, vbNullString, vbNormalFocus
End Sub

Public Function ExcelInstalled() As Boolean
    On Error GoTo ExcelInstalledErr
    Dim XLApp As Object
    Set XLApp = CreateObject("Excel.Application")
    Sleep 100
    DoEvents
    XLApp.Quit
    Sleep 100
    DoEvents
    Set XLApp = Nothing
    ExcelInstalled = True
    Exit Function
    '
ExcelInstalledErr:
    If Err.Number = 429 Then
        ExcelInstalled = False
    Else
        errhandler "Function ExcelInstalled", Err.Number, Err.Description
    End If
End Function

Public Sub PrinttoPrinter()
    '======================================================
    'NEEDS
    '======================================================
    'PRINTS NONCENTERED TALLER THAN WIDE OKAY
    'DOESN'T PRINT WIDER THAN TALL AT ALL!
    '======================================================
    On Error GoTo PrintParabolaErr
    Screen.MousePointer = vbHourglass
    'print parabola to printer, scale to printer object, use 1 px line
    Dim ScalingFactor As Single, Xadjust As Single, n As Long
    Printer.DrawWidth = 2   '1
    Printer.ForeColor = vbBlack
    '----------------------------------------------------
    'scale portrait or landscape to get biggest printout
    'get scalefactor based on greatest dimension: width or height
    '----------------------------------------------------
'    n = UBound(GraphPoints, 2)
    If Abs(GraphPoints(1, 1) * 2) > GraphPoints(2, 1) Then
        'parabola is wider than it is tall : 2*max X > max Y
        Printer.Orientation = vbPRORLandscape
        'scalefactor is based on max X value
        ScalingFactor = Printer.ScaleWidth / Abs(GraphPoints(1, 1) * 2) 'max x value * 2
'        Xadjust = Abs(GraphPoints(1, 1))                             'get x value from 1st array element
'        'now adding Xadjust to min to max X values will start X values at 0 not center them
'        'to center them we need to subtract the -x to +x from printer.scalewidth
'        Xadjust = Xadjust + Printer.ScaleWidth - (2 * Xadjust)
    Else
        'parabola is taller than it is wide
        Printer.Orientation = vbPRORPortrait
        'scalefactor is based on max Y value
        ScalingFactor = Printer.ScaleHeight / GraphPoints(2, 1) 'max y value
        'center x values on printout
'        Xadjust = (Printer.ScaleWidth - (Abs(GraphPoints(1, 1)) * ScalingFactor)) / ScalingFactor  'get x value from 1st array element
    End If
    '----------------------------------------------------
    'center x values on printer
    '----------------------------------------------------
    Xadjust = Abs(GraphPoints(1, 1))                             'get x value from 1st array element
    'now adding Xadjust to min to max X values will start X values at 0 not center them
    'to center them we need to subtract the -x to +x from printer.scalewidth
'    Xadjust = Xadjust + Printer.ScaleWidth / ScalingFactor - (2 * Xadjust)
    '----------------------------------------------------
    'print all points in array scaled to printer object
    '----------------------------------------------------
    'draw center X value to max X value
'    n = LBound(GraphPoints, 2)
    Printer.CurrentX = (GraphPoints(1, 1) + Xadjust) * ScalingFactor
    Printer.CurrentY = GraphPoints(2, 1) * ScalingFactor
'    For n = LBound(GraphPoints, 2) To UBound(GraphPoints, 2)
    For n = 2 To UBound(GraphPoints, 2)
        Printer.Line -((GraphPoints(1, n) + Xadjust) * ScalingFactor, GraphPoints(2, n) * ScalingFactor)
    Next n
    'draw center X value to min X value
'    n = LBound(GraphPoints, 2)
    Printer.CurrentX = (GraphPoints(1, 1) + Xadjust) * ScalingFactor
    Printer.CurrentY = GraphPoints(2, 1) * ScalingFactor
'    For n = LBound(GraphPoints, 2) To UBound(GraphPoints, 2)
    For n = 2 To UBound(GraphPoints, 2)
        Printer.Line -(-1 * ((GraphPoints(1, n) + Xadjust)) * ScalingFactor, GraphPoints(2, n) * ScalingFactor)
    Next n
    '----------------------------------------------------
    'print focal point
    '----------------------------------------------------
    Printer.DrawWidth = 50
    Printer.PSet ((GraphPoints(1, 1) + Xadjust * ScalingFactor), CDbl(frmInput.lblFocalLength.Caption) * ScalingFactor), vbBlack
    '----------------------------------------------------
    Printer.EndDoc
    MsgBox "Printout is completed!"
    Screen.MousePointer = vbDefault
    Exit Sub
    '
PrintParabolaErr:
    Screen.MousePointer = vbDefault
    errhandler "Sub PrintParabola", Err.Number, Err.Description
End Sub
