VERSION 5.00
Begin VB.Form frmWifiCentered 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Wifi Calculations for Parabolic Dish with Centered Feedhorn"
   ClientHeight    =   2370
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   10590
   Icon            =   "frmWifiCentered.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2370
   ScaleWidth      =   10590
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.CommandButton btnHelp 
      Caption         =   "&Help"
      Height          =   375
      Left            =   1830
      TabIndex        =   17
      Top             =   2370
      Visible         =   0   'False
      Width           =   780
   End
   Begin VB.Frame Frame1 
      Caption         =   "Inputs"
      Height          =   1725
      Left            =   90
      TabIndex        =   9
      Top             =   120
      Width           =   3285
      Begin VB.TextBox txtFreq 
         Height          =   285
         Left            =   1440
         TabIndex        =   0
         Top             =   270
         Width           =   1245
      End
      Begin VB.TextBox txtDiameter 
         Height          =   285
         Left            =   1440
         TabIndex        =   1
         Top             =   600
         Width           =   1245
      End
      Begin VB.TextBox txtDepth 
         Height          =   285
         Left            =   1440
         TabIndex        =   2
         Top             =   930
         Width           =   1245
      End
      Begin VB.OptionButton optUnits 
         Caption         =   "mm."
         Height          =   255
         Index           =   0
         Left            =   1440
         TabIndex        =   3
         Top             =   1350
         Width           =   585
      End
      Begin VB.OptionButton optUnits 
         Caption         =   "in."
         Height          =   255
         Index           =   1
         Left            =   2070
         TabIndex        =   4
         Top             =   1350
         Width           =   585
      End
      Begin VB.Label Label1 
         AutoSize        =   -1  'True
         Caption         =   "Enter Frequency"
         Height          =   195
         Index           =   0
         Left            =   180
         TabIndex        =   16
         Top             =   360
         Width           =   1170
      End
      Begin VB.Label Label2 
         AutoSize        =   -1  'True
         Caption         =   "MHz"
         Height          =   195
         Index           =   0
         Left            =   2760
         TabIndex        =   15
         Top             =   360
         Width           =   330
      End
      Begin VB.Label Label1 
         AutoSize        =   -1  'True
         Caption         =   "Enter Diameter"
         Height          =   195
         Index           =   1
         Left            =   180
         TabIndex        =   14
         Top             =   690
         Width           =   1050
      End
      Begin VB.Label lblUnits 
         AutoSize        =   -1  'True
         Caption         =   "mm."
         Height          =   195
         Index           =   0
         Left            =   2760
         TabIndex        =   13
         Top             =   690
         Width           =   285
      End
      Begin VB.Label lblDepth_f_over_D 
         AutoSize        =   -1  'True
         Caption         =   "Enter Depth"
         Height          =   195
         Left            =   180
         TabIndex        =   12
         Top             =   1020
         Width           =   855
      End
      Begin VB.Label lblUnits 
         AutoSize        =   -1  'True
         Caption         =   "mm."
         Height          =   195
         Index           =   1
         Left            =   2760
         TabIndex        =   11
         Top             =   1020
         Width           =   285
      End
      Begin VB.Label Label1 
         AutoSize        =   -1  'True
         Caption         =   "Select Units"
         Height          =   195
         Index           =   3
         Left            =   180
         TabIndex        =   10
         Top             =   1380
         Width           =   855
      End
   End
   Begin VB.CommandButton btnSave 
      Caption         =   "&Save"
      Height          =   375
      Left            =   1185
      TabIndex        =   6
      ToolTipText     =   "Save Data to File"
      Top             =   1920
      Width           =   1100
   End
   Begin VB.CommandButton btnExit 
      Caption         =   "E&xit"
      Height          =   375
      Left            =   2280
      TabIndex        =   7
      ToolTipText     =   "Close this Form"
      Top             =   1920
      Width           =   1100
   End
   Begin VB.TextBox txtOutput 
      Height          =   2085
      Left            =   3480
      MultiLine       =   -1  'True
      TabIndex        =   8
      TabStop         =   0   'False
      Top             =   180
      Width           =   7000
   End
   Begin VB.CommandButton btnCalc 
      Caption         =   "&Calculate"
      Height          =   375
      Left            =   90
      TabIndex        =   5
      Top             =   1920
      Width           =   1100
   End
End
Attribute VB_Name = "frmWifiCentered"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim freq                    As Double
Dim wavelength              As Double
Dim units                   As String
Dim s1                      As String
Dim metric                  As Double
Dim Diameter                As Double
'Dim Depth                   As Double
Dim focal_length            As Double
'Dim f_over_D                As Double
Dim feedangle               As Double
Dim feedang_deg             As Double
Dim R_edge                  As Double
Dim space_attn              As Double
Dim desired_taper           As Double
Dim BW3                     As Double
Dim simple_horn_diameter    As Double
Dim efficiency              As Double
Dim radius                  As Double
Dim aperture                As Double
Dim dish_gain               As Double

Const c                     As Double = 299792456#  ' meters per second
Const crad                  As Double = 57.29578

Private Sub btnCalc_Click()
    On Error GoTo btnCalc_ClickErr
    '---------------------------------
    'basics
    '---------------------------------
    btnSave.Enabled = False     'don't allow nothing to be saved
    s1 = ""                     'results for output textbox
    '---------------------------------
    'are inputs numeric
    '---------------------------------
    If Not IsNumeric(txtFreq.Text) Then
        MsgBox "Non-numeric input for Frequency", vbOKOnly, "Please enter ONLY numeric values"
        txtFreq.SetFocus
        txtFreq.SelStart = 0
        txtFreq.SelLength = Len(txtFreq.Text)
        Exit Sub
    End If
    If Not IsNumeric(txtDiameter.Text) Then
        MsgBox "Non-numeric input for Diameter", vbOKOnly, "Please enter ONLY numeric values"
        txtDiameter.SetFocus
        txtDiameter.SelStart = 0
        txtDiameter.SelLength = Len(txtDiameter.Text)
        Exit Sub
    End If
    If Not IsNumeric(txtDepth.Text) Then
        If frmInput.mnuOptionsInputsDiameterDepth.Checked = True Then
            'enter Diameter and Depth
            MsgBox "Non-numeric input for Depth", vbOKOnly, "Please enter ONLY numeric values"
        Else
            'enter Diameter and f/D
            MsgBox "Non-numeric input for f/D", vbOKOnly, "Please enter ONLY numeric values"
        End If
        txtDepth.SetFocus
        txtDepth.SelStart = 0
        txtDepth.SelLength = Len(txtDepth.Text)
        Exit Sub
    End If
    If optUnits(0).value = False And optUnits(1).value = False Then
        MsgBox "You did not select Units: Inches or Millimeters" & vbCrLf & "Millimeters will be selected", vbOKOnly, "No Units Selected"
        optUnits(0).SetFocus
        Exit Sub
    End If
    '---------------------------------
    'd.get_freq()
    '---------------------------------
    freq = CDbl(txtFreq.Text)
    wavelength = c / (1000# * freq)
    '---------------------------------
    'dd.d_init()
    '---------------------------------
    'enter diameter
    Diameter = CDbl(txtDiameter.Text) * metric
    'calculate/input depth, focal length, and f/D
    If frmInput.mnuOptionsInputsDiameterDepth.Checked = True Then
        'enter Diameter and Depth
        'Depth = CDbl(txtDepth.Text) * metric
        'Depth is now stored in a global variable and is read from the frmInput
        Depth = CDbl(frmWifiCentered.txtDepth.Text)
        focal_length = (Diameter * Diameter) / (16# * Depth * metric)
        f_over_D = focal_length / Diameter
    Else
        'enter Diameter and f/D
        f_over_D = CDbl(txtDepth.Text)
        focal_length = f_over_D * Diameter
        'http://www.analyzemath.com/parabola/parabola_focus.html
        'focal_length=Diameter^2/(16*depth)
        'depth * 16 = Diameter^2/focal_length
        Depth = (Diameter ^ 2) / (16 * focal_length * metric)
    End If
    s1 = "f/D = " & Format$(f_over_D, "0.00") & vbCrLf
    s1 = s1 & "Focal Length = " & Format$((focal_length / metric), "0.00") & " " & units & vbCrLf
    '---------------------------------
    'Dish::illumination()
    '---------------------------------
    feedangle = 2 * Atan2(1#, ((2# * f_over_D) - (1# / (8# * f_over_D))))
    feedang_deg = crad * feedangle                              'degrees conversion
    'R_edge = distance from focal point to edge
    R_edge = 2# * focal_length / (1 + Cos(feedangle / 2#))
    'Space_attn is additional path loss to edge of dish
    space_attn = (20# * Log10(R_edge / focal_length))
    'Desired_taper to achieve 10 dB actual edge taper
    desired_taper = 10# - space_attn                            'dB
    BW3 = feedangle * Sqr(3# / desired_taper)
    simple_horn_diameter = 66# / (BW3 * crad)                   'wavelengths
    s1 = s1 & "Illumination angle for feed = " & Format$(feedang_deg, "0.0") & " degrees" & vbCrLf
    s1 = s1 & "Space attenuation = " & Format$(space_attn, "0.00") & " dB " & vbCrLf
    s1 = s1 & "Desired taper = " & Format$(desired_taper, "0.00") & " db for 10 dB edge illumination" & vbCrLf
    s1 = s1 & "A simple feed horn would have a diameter of " & Format$(simple_horn_diameter, "0.00") & " wavelengths for a 3 dB beamwidth of " & Format$((BW3 * crad), "0.00") & " degrees" & vbCrLf
    '---------------------------------
    'd.calc_gain()
    '---------------------------------
    efficiency = 0.5                                            'assume 50% efficiency
    radius = 0.5 * Diameter
    aperture = pi * radius * radius
    dish_gain = efficiency * aperture * 4# * pi / (wavelength * wavelength)
    dish_gain = 10# * Log10(dish_gain)
    s1 = s1 & "Gain at 50% efficiency = " & Format$(dish_gain, "0.00") & " dBi"
    '---------------------------------
    'display results
    '---------------------------------
    txtOutput.Text = s1
    'WifiCalculations = s1
    btnSave.Enabled = True
    DoEvents
    Exit Sub
    '
btnCalc_ClickErr:
    btnSave.Enabled = False
    txtOutput.Text = ""
    'WifiCalculations = ""
    errhandler "btnCalc_Click", Err.Number, Err.Description & vbCrLf & vbCrLf & "Please Verify the the Dimensions"
End Sub

Private Sub btnExit_Click()
    Unload frmWifiCentered
    Set frmWifiCentered = Nothing
End Sub

Private Sub btnHelp_Click()
    MsgBox "These results will be saved at the end of the" & vbCrLf & _
           "output file when you use the main menu choice:" & vbCrLf & vbCrLf & _
           """File > Save Data to Ascii Text (.txt) File""", vbOKOnly, "Saving These Results"
End Sub

Private Sub btnSave_Click()
    SaveWifiTextFile (txtOutput.Text)
End Sub

Private Sub Form_Load()
    On Error GoTo Form_LoadErr
    Dim s1 As String
    '-----------------------
    'load textbox text
    '-----------------------
    s1 = "Enter the Frequency, Parabola Dimensions, and select the Units" & vbCrLf & vbCrLf
    s1 = s1 & "The WiFi calculations and output text are copied directly from the source code of the hdl_ant program written by Paul Wade, you can find the program here:" & vbCrLf & vbCrLf
    s1 = s1 & "http://www.w1ghz.org/10g/software.htm" & vbCrLf & vbCrLf
    s1 = s1 & "There is a link to this site on the ""Help > About"" form."
    txtOutput.Text = s1
    '-----------------------
    'default to metric
    '-----------------------
    metric = 1
    units = "mm."
    '------------------------------------------
    'enter Diameter and Depth or f/D
    '------------------------------------------
    If frmInput.mnuOptionsInputsDiameterDepth.Checked = True Then
        'user selected to enter Diameter and Depth
        lblDepth_f_over_D.Caption = "Enter Depth"
    Else
        'user selected to enter Diameter and f/D
        lblDepth_f_over_D.Caption = "Enter f/D"
    End If
    If frmInput.txtDepth.Text <> "" Then frmWifiCentered.txtDepth = frmInput.txtDepth
    '-----------------------
    'enter Diameter
    '-----------------------
    frmWifiCentered.txtDiameter = frmInput.txtDiameter
    DoEvents
    Exit Sub
    '
Form_LoadErr:
    errhandler "Form Wifi Form_Load Event", Err.Number, Err.Description
End Sub

Public Function Atan2(y As Double, x As Double) As Double
    'http://forums.devx.com/showthread.php?t=69063
    If x > 0 Then
        Atan2 = Atn(y / x)
    ElseIf x < 0 Then
        Atan2 = Sgn(y) * (pi - Atn(Abs(y / x)))
    ElseIf y = 0 Then
        Atan2 = 0
    Else
        Atan2 = Sgn(y) * pi / 2
    End If
End Function

Static Function Log10(x)
   Log10 = Log(x) / Log(10#)
End Function

'const double c = 299792456.0    //  meters per second
'const double pi = 3.1415927
'const double crad = 57.29578
'char *units = " mm.
'float metric = 1.0
'
'    metric = 25.4
'    units = " inches "
'    unit_type = "English"
'----------------------------
'    metric = 1.0
'    units = " mm.
'    unit_type = "Metric "
'
'case 'D': pdish()
'
'void pdish(){
'    PARABOLIC DISH ANTENNA CALCULATIONS
'    Dish d;
'    d.get_freq();
'    d.d_init();
'    d.illumination();
'    d.calc_gain();
'}
'
'void Antenna::get_freq(){
'    "Frequency in MHz: "
'    cin >> freq ;
'    wavelength = c / (1000.0 * freq);
'}
'
'void Dish::d_init(){
'    cout << "Diameter of dish in " << units; cin >> diameter ;
'    diameter *= metric;
'    cout << "Do you know the f/D ratio [Y or N]?"; cin >> mode;
'    if (mode == 'Y')    {
'        cout "Enter f/D ratio"
'        cin >> f_over_D;
'        focal_length = f_over_D * diameter
'    } else {
'        cout << "Enter Depth of dish in " << units
'        cin >> depth; depth *= metric;
'        focal_length = (diameter * diameter) / ( 16.0 * depth);
'        f_over_D = focal_length / diameter ;
'        cout << "f/D = " << f_over_D << "\n" ;
'    }
'    cout << "\nFocal length = " (focal_length / metric) " " units << endl;
'}
'
'void Dish::illumination(){
'    feedangle = 2 * atan2(1.0,((2.0 * f_over_D) - (1.0/(8.0 * f_over_D))));
'    feedang_deg = crad * feedangle ;   // degrees conversion
'    // R_edge = distance from focal point to edge
'    R_edge = 2.0 * focal_length / ( 1 + cos(feedangle/2.0));
'    // Space_attn is additional path loss to edge of dish
'    double Space_attn = (20.0 * log10(R_edge / focal_length));
'    // Desired_taper to achieve 10 dB actual edge taper
'    double Desired_taper = 10.0 - Space_attn;  // dB
'    BW3 = feedangle * sqrt( 3.0 / Desired_taper) ;
'    double Simple_horn_diameter = 66.0 / (BW3 * crad) ; // wavelengths
'    cout << "Illumination angle for feed = " feedang_deg  " degrees"
'    cout << "Space attenuation = " Space_attn << " dB "
'    cout << "Desired taper = " Desired_taper << " db " "for 10 dB edge illumination";
'    cout << "A simple feed horn would have a diameter of " Simple_horn_diameter << " wavelengths";
'    cout << " for a 3 dB beamwidth of " (BW3 * crad) << " degrees";
'}
'
'
'void Dish::calc_gain(){
'    efficiency = 0.5;     // assume 50% efficiency
'    double radius = 0.5 * diameter;
'    aperture = pi * radius * radius;
'    dish_gain = efficiency * aperture * 4.0 * pi / (wavelength * wavelength);
'    dish_gain = 10.0 * log10(dish_gain);
'    cout << "Gain at 50% efficiency = " << dish_gain << " dBi";
'}
Private Sub optUnits_Click(Index As Integer)
    'update labels and multiplier
    Select Case Index
        Case 0
            lblUnits(0).Caption = "mm."
            lblUnits(1).Caption = "mm."
            units = "mm."
            metric = 1
        Case 1
            lblUnits(0).Caption = "in."
            lblUnits(1).Caption = "in."
            units = "in."
            metric = 25.4
    End Select
    'if inputs already entered then do calculation
    If IsNumeric(txtFreq.Text) And IsNumeric(txtDiameter.Text) And IsNumeric(txtDepth.Text) Then
        btnCalc.value = True
    Else
        txtOutput.Text = ""
        'WifiCalculations = ""
    End If
End Sub
