Attribute VB_Name = "modExcel"
Option Explicit

'----------------------------------------------------------------------------------
'    N o t e s
'----------------------------------------------------------------------------------
'    Dim oXLApp As Excel.Application         'Declare the object variables
'    Dim oXLBook As Excel.Workbook
'    Dim oXLSheet As Excel.Worksheet
'    Set oXLApp = New Excel.Application    'Create a new instance of Excel
'    Set oXLBook = oXLApp.Workbooks.Add    'Add a new workbook
'    Set oXLSheet = oXLBook.Worksheets(1)  'Work with the first worksheet
'    Set oXLSheet = Nothing             'disconnect from the Worksheet
'    oXLBook.Close SaveChanges:=True    'Save (and disconnect from) the Workbook
'    Set oXLBook = Nothing
'    oXLApp.Quit                        'Close (and disconnect from) Excel
'    Set oXLApp = Nothing
'    oXLBook.SaveAs "C:\My Documents\My File.xls"  'Save (and disconnect from) the Workbook
'    oXLBook.Close SaveChanges:=False
'    Set oXLBook = Nothing
'    oXLApp.Quit                                   'Close (and disconnect from) Excel
'    Set oXLApp = Nothing
'----------------------------------------------------------------------------------
'    Dim my_variable As String
'    my_variable = oXLSheet.Cells(2, 1).Value
'    This copies the text in the cell A2 (specified in the brackets: row 2, column 1) to the variable "my_variable".
'    To write a single cell you just need to change the order of the expression like this:
'    visual basic code:Dim my_variable As String my_variable = "hello"
'    oXLSheet.Cells(2, 1).Value = my_variable
'    'or just this:
'    oXLSheet.Cells(2, 1).Value = "hello"
'----------------------------------------------------------------------------------
'   oXLSheet.Cells(3, 1).Formula = "=A1+2"
'   oXLSheet.Range("D3:E5").Value = 3
'----------------------------------------------------------------------------------
'    Dim lMyArray(2, 1) As Long
'    lMyArray(0, 0) = 1
'    lMyArray(0, 1) = 2
'    lMyArray(1, 0) = 3
'    lMyArray(1, 1) = 4
'    lMyArray(2, 0) = 5
'    lMyArray(2, 1) = 6
'    oXLSheet.Range("D7:E9").Value = lMyArray
'    =====================
'    Dim vArray As Variant
'    vArray = oXLSheet.Range("D7:E9").Value
'----------------------------------------------------------------------------------
'    Dim vArray As Variant
'    vArray = oXLSheet.UsedRange.Value
'    'vArray now contains the values of ALL the cells in used range of the worksheet.
'    'example usage of the array:
'    Dim lngCol As Long, lngRow As Long
'    For lngRow = 1 To UBound(vArray, 1)
'        For lngCol = 1 To UBound(vArray, 2)
'            MsgBox vArray(lngRow, lngCol)
'        Next lngCol
'    Next lngRow
'----------------------------------------------------------------------------------
'    Note that Underline does not use Boolean values, as there are various options
'    for underlining (such as single or double underline). When you type in the =
'    after Font.Underline a list of the values should appear, so that you can simply
'    select the appropriate one (the value to turn underlining off is xlUnderlineStyleNone).
'    To change the text colour of the same cell to green you can do this:
'        With oXLSheet.Range("A4")
'           .Font.ColorIndex = 50
'        End With
'    To align the text within cells you can use a couple of extra properties,
'    one for horizontal and one for vertical:
'        With oXLSheet.Range("A4")
'           .HorizontalAlignment = xlRight    '(other options include xlCenter and xlLeft)
'           .VerticalAlignment = xlBottom     '(other options include xlCenter and xlBottom)
'        End With
'    The alternative range objects we are interested in are Rows and Columns.
'    Both of these take a single parameter, which is the row or column number
'    we want to work with, and can be used in the same way as Cells or Range, eg:
'        oXLSheet.Rows(7).Font.Bold = True     '(False to turn bold off)
'        oXLSheet.Columns(3).Font.Bold = True  '(False to turn bold off)
'    You can also select multiple adjacent columns/rows by providing a string
'    parameter instead of a number, which contains the first and last row/column
'    separated by a colon (if you provide a string for Columns, it must be the column
'    name rather than number), eg:
'        oXLSheet.Rows("6:7").Font.Bold = True '(False to turn bold off)
'        oXLSheet.Columns("C:E").Font.Bold = True  '(False to turn bold off)
'----------------------------------------------------------------------------------
'    Finding "special" cells (bottom row etc)
'    As you may already know, when you are editing a spreadsheet manually you can press Ctrl and an arrow key to go to the next/last cell in that direction which contains text. There are also methods of performing this via code.
'    Here is one method to find the last used row/column in the sheet:
'       LastRow = oXLSheet.UsedRange.Rows.Count
'       LastCol = oXLSheet.UsedRange.Columns.Count
'    NB: UsedRange is a special pre-defined range which contains the entire used area of the sheet.
'    Here is an alternative - but note that this method assumes that every row has data in all columns (and vice versa). If this is not the case, it is safer to use the options above/below instead.
'        LastRow = oXLSheet.Range("A1").End(xlDown).Row
'        LastCol = oXLSheet.Range("A1").End(xlToRight).Column
'    There is also another built-in function in Excel for detecting used ranges, the .SpecialCells function retrieves a number of "special range" values depending on the constant value passed to the function. Here is the equivalent to the code above (works by going to the 'last' used cell):
'       LastRow = oXLSheet.Cells.SpecialCells(xlCellTypeLastCell).Row
'       LastCol = oXLSheet.Cells.SpecialCells(xlCellTypeLastCell).Column
'    Some of the other parameters for the SpecialCells method are:
'        * xlCellTypeAllValidation - Cells having validation criteria
'        * xlCellTypeBlanks - Empty cells
'        * xlCellTypeComments - Cells containing notes
'        * xlCellTypeFormulas - Cells containing formulas
'----------------------------------------------------------------------------------
'    If you find that after running your program you still have an open
'    copy of Excel that you weren't expecting (either visible, or shown
'    in Task Manager) then I'm afraid that you have made a mistake somewhere in your code.
'    It may be that you haven't used appropriate code to close the
'    sheet/workbook/application (see post #5 for valid examples). This is
'    particularly true if you have not used a variable to store the WorkSheet
'    (as several people seem to do), as it is easy to refer to the WorkBook
'    instead (which isn't technically valid, even tho it works); I would
'    therefore strongly recommend using variable for it.
'    If as part of "closing down" you miss a child object variable (which is
'    basically what happens in the above) and destroy the application object,
'    it will orphan the child object variable and cause the instance of Excel
'    to remain because not all resources associated with the application instance
'    have been closed and destroyed.
'    It may be that you have used objects that are ok in Excel VBA code, but not
'    in a VB application. Common examples of this are Selection (which needs to
'    be oXLApp.Selection), ActiveSheet (which should be a variable like oXLSheet),
'    and Application (which needs to be oXLApp).
'    As a side note, it is advisable to avoid using Selection and ActiveSheet
'    altogether (even in Excel VBA code), as this can be changed by the user if
'    they are working in Excel while your code is running - which means you could
'    well be working in the wrong worksheet/workbook!
'----------------------------------------------------------------------------------
'    Using a Late-Bound connection to Excel
'    The code so far in this tutorial has been Early-Bound (i.e.: VB knows in
'    advance what Excel functions are available to you), which as seen in the
'    previous section can cause serious issues.
'    Unless you can guarantee that all of your users have the same version of
'    Excel installed as you do, I would strongly recommend converting to Late-bound
'    for software that you release "into the wild".
'    The down-side to using this is that you no longer get some of the nice
'    features of the VB IDE (like the drop-down lists of properties and methods
'    that appear when you type oXLApp. ), so it may be a good idea to convert
'    to this method once your code is finished.
'    There are four steps to convert your code:
' 1) Replace Excel data types with Object.
'    If you have:'
'        visual basic code:Dim oXLApp as Excel.Application
'        Dim oXLBook As Excel.Workbook
'        Dim oXLSheet As Excel.Worksheet
'        ...
'    You need to change it to:
'        visual basic code:Dim oXLApp as Object
'        Dim oXLBook As Object
'        Dim oXLSheet As Object
'        ...
'    Note that you should also do this with any other variables that you have
'    declared as Excel.something
' 2) Change the initialisation of the application object.
'    If you have:
'        visual basic code:Set oXLApp = New Excel.Application
'    You should replace it with:
'        visual basic code:Set oXLApp = CreateObject("Excel.Application")
'    Note: if Excel isnt installed, this line of code will cause an error 
'    you should deal with this by using error handling in an appropriate way for your project.
' 3) Define the constants that you have used.
'    Excel constants (e.g.: xlLeft) are defined in the object library;
'    however you will no longer have a link to this, so they wont be defined any more!
'    There are two main options here;
'    the first is to use the Object Browser to find the values/declarations
'    for each one you have used (very slow, and prone to errors!),
'    and the other (much simpler) is to add a pre-made module to your project
'    which declares them all for you. You can find a link to one which Microsoft
'    produced in the useful functions and downloads section (post #13).
' 4) Remove "Excel object Library" from the list in "Project" -> "References"
'    Your code is now late-bound, and should work with all versions of Excel
'    that support automation (as long as you havent used special functionality
'    which wasnt available in earlier versions).
'----------------------------------------------------------------------------------
'     How do I write code to  ? [a.k.a. recording macro's]
'    There are many things which can be done with Excel that haven't been listed here, and there is a good reason - Excel will tell you the code you need!
'
'    If you record a macro in Excel, it is 'written' in VBA (a subset of VB), and this code can be copied almost directly into your VB program, with only a few modifications to use the objects you have created rather than the default Application/Sheet/etc objects [failure to do this part will most likely cause your program to have bugs, or even cause your computer to crash].
'
'    To record a macro:
'
'        * Go to "Tools" -> "Macro" -> "Record new macro".
'        * Manually do the things that you want your program to do.
'        * Press the "stop recording" button (a blue square).
'        * Go to "Tools" -> "Macro" -> "Macros...", which will show a list of macros.
'        * Select the macro you recorded, and click on "Edit" to see the code.
'
'
'
'    There are 4 steps you should perform when taking code from a macro to use in your program, they are:
'
'       1. Remove un-needed code (as Excel often does extra things, such as writing all values from an options screen).
'       2. Change ActiveDocument, Application etc to suit the variables in your code.
'       3. Change Selection to oXLApp.Selection.
'       4. Prefix all instances of Range/Cells/Rows/Columns/etc with your sheet object.
'
'
'    Example 1:
'    The following code is created if you select a range, then set it to Bold and Italic:
'
'    visual basic code:    Range("C9:F16").Select
'        Selection.Font.Bold = True
'        Selection.Font.Italic = True
'
'
'    In this case there is no un-needed code, so we can skip step 1.
'
'    There is no use of ActiveDocument etc, so we can also skip step 2.
'
'    Following step 3 gives us this:
'
'    visual basic code:    Range("C9:F16").Select
'        oXLApp.Selection.Font.Bold = True
'        oXLApp.Selection.Font.Italic = True
'
'
'    And step 4 gives us this:
'
'    visual basic code:    oXLSheet.Range("C9:F16").Select
'        oXLApp.Selection.Font.Bold = True
'        oXLApp.Selection.Font.Italic = True
'
'
'    As mentioned in the previous post, it is best to avoid Selection altogether. This can be done by changing the code to this:
'
'    visual basic code:    oXLSheet.Range("C9:F16").Font.Bold = True
'        oXLSheet.Range("C9:F16").Font.Italic = True
'
'    ..or you can do it like this instead (a bit more efficient, and easier to read):
'
'    visual basic code:    With oXLSheet.Range("C9:F16")
'          .Font.Bold = True
'          .Font.Italic = True
'        End With
'
'
'
'
'    Example 2:
'    As another example, here is part of the code created if you go into "File"->"Page Setup", then set the orientation to Landscape, and set the "rows to repeat at top" to $1:$2
'
'    visual basic code:    With ActiveSheet.PageSetup
'            .PrintTitleRows = "$1:$2"
'            .PrintTitleColumns = ""
'        End With
'        ActiveSheet.PageSetup.PrintArea = ""
'        With ActiveSheet.PageSetup
'            .LeftHeader = ""
'            .CenterHeader = ""
'    ... (lots of lines removed!)  ...
'            .CenterVertically = False
'            .Orientation = xlLandscape
'            .Draft = False
'            .PaperSize = xlPaperA4
'            .FirstPageNumber = xlAutomatic
'            .Order = xlDownThenOver
'            .BlackAndWhite = False
'            .Zoom = 100
'        End With
'
'
'
'    Following step 1 gives us this:
'
'    visual basic code:    With ActiveSheet.PageSetup
'            .PrintTitleRows = "$1:$2"
'        End With
'        With ActiveSheet.PageSetup
'            .Orientation = xlLandscape
'        End With
'
'
'    Which can be shortened to this:
'
'    visual basic code:    With ActiveSheet.PageSetup
'            .PrintTitleRows = "$1:$2"
'            .Orientation = xlLandscape
'        End With
'
'
'    From there, following step 2 gives us this:
'
'    visual basic code:    With oXLSheet.PageSetup
'            .PrintTitleRows = "$1:$2"
'            .Orientation = xlLandscape
'        End With
'
'
'    In this case, there is nothing to do for steps 3 and 4.
'----------------------------------------------------------------------------------
'    How do I work with a copy of Excel that is already open?
'    This will connect the application object to an open copy of Excel:
'       Set oXLApp = GetObject(,"Excel.Application")
'    Please note that there is no way to specify which open copy of
'    Excel to work with, so if there is more than one open you cannot
'    predict which one will be referenced.
'----------------------------------------------------------------------------------

'------------------------------------------------
' necessary form inputs
'------------------------------------------------
'    (not text) ship to united states
'    full Name
'    address1
'    city
'    state
'    Weight lbs
'    Weight ozs
'    (not text) size > 84 in's
'    (not text) shipping Date
'    (not text) shipping from zip code same as return address from above
'------------------------------------------------

Public Enum ColumnHeaders
    Full_Name = 1
    Company = 2
    Address = 3
    Address2 = 4
    city = 5
    state = 6
    zip = 7
    Phone = 8
    Email = 9
    Edge = 10
    Edge_Ship = 11
    SU_31 = 12
    SU_31_Ship = 13
    Shipping_Weight_LBS = 14
    Shipping_Weight_OZS = 15
    Date_Shipped = 16
    Shipping_Cost = 17
    Date_Funds_Received = 18
    Owe_Supplier = 19
    Paid_Supplier = 20
    Check_Number = 21
    Cost_Per_Kit = 22
End Enum

Public WorksheetData()  As String

Public Function ExcelInstalled() As Boolean
    On Error GoTo ExcelInstalledErr
    Dim XLApp As Object
    'run excel
    Set XLApp = CreateObject("Excel.Application")
    DoEvents
    'stop excel
    XLApp.Quit
    DoEvents
    'destroy object
    Set XLApp = Nothing
    'no errors indicate that excel ran so it must be installed
    ExcelInstalled = True
    Exit Function
    '
ExcelInstalledErr:
    If Err.Number = 429 Then
        ExcelInstalled = False
    Else
        errhandler "Function ExcelInstalled", Err.Number, Err.Description
        ExcelInstalled = False
    End If
End Function

'Public Function ReadExcelDataIntoArray() As Boolean
'    On Error GoTo ReadExcelDataIntoArrayErr
''    Load frmProgress
''    frmProgress.Visible = True
'    '-----------------------------------------------
'    'see if Excel is installed on local machine
'    '-----------------------------------------------
'    If Not ExcelInstalled Then
'        'Excel Is Not Installed
''        Unload frmProgress
''        Set frmProgress = Nothing
'        MsgBox "Excel is not installed on this computer." & vbCrLf & vbCrLf & _
'               "This function will not work without a valid Microsoft Excel Installation.", vbOKOnly, "Excel Not Installed"
'        ReadExcelDataIntoArray = False
'        Exit Function
'    End If
'    '-----------------------------------------------
'    'Excel Is Installed, declare variables
'    '-----------------------------------------------
''    frmProgress.lblStatus.Caption = "Excel is Installed"
''    frmProgress.Refresh
'    DoEvents
'    Screen.MousePointer = vbHourglass
'    'variables for excel
'    Dim objXL       As Excel.Application
'    Dim wbXL        As Excel.Workbook
'    Dim wsXL        As Excel.Worksheet
'    'general variables
'    Dim rownum As Long, colnum As Long, DateString As String, pos As Long
'    Dim linedata() As String, n As Long, entrycounter As Long
'    Dim ExcelWorksheetCellsUsed As Variant
'    '------------------------------------------------
'    'Run Excel, Open Worksheet
'    '------------------------------------------------
''    frmProgress.lblStatus.Caption = "Please Wait - Running Excel"
''    frmProgress.Refresh
'    DoEvents
'    Set objXL = New Excel.Application
'    DoEvents
'    objXL.Visible = True
'    'Open an existing workbook
''    frmProgress.lblStatus.Caption = "Please Wait - Loading Workbook"
''    frmProgress.Refresh
'    DoEvents
'    Set wbXL = objXL.Workbooks.Open(frmMain.lblExcelWorkbook.Caption)
'    DoEvents
'    Set wsXL = objXL.ActiveSheet
'    DoEvents
'    'get range of used cells on this worksheet
'    ExcelWorksheetCellsUsed = wsXL.UsedRange.Value
'    '------------------------------------------------
'    'read data into array
'    '------------------------------------------------
''    frmProgress.lblStatus.Caption = "Please Wait - Reading Workbook Data"
''    frmProgress.Refresh
'    DoEvents
'    'redim array
'    ReDim WorksheetData(1 To 21, 1 To 10)
'    entrycounter = 0
'    'start at row 2, row 1 is colunmn labels
'    For rownum = 2 To UBound(ExcelWorksheetCellsUsed, 1)
'        '--------------------------------------
'        'if there is no name entry, exit loop
'        If Trim$(wsXL.Cells(rownum, 1).Text) = "" Then Exit For
'        entrycounter = entrycounter + 1
'        '--------------------------------------
'         'make array larger if necessary
'        If entrycounter > UBound(WorksheetData, 2) Then
'            ReDim Preserve WorksheetData(1 To 21, 1 To UBound(WorksheetData, 2) + 10)
'        End If
'        '--------------------------------------
'        'show user what's happening
'        wsXL.Rows(rownum).Select
'        For colnum = 1 To 21
'            'wsXL.Cells(rownum, colnum).Select
'            WorksheetData(colnum, entrycounter) = wsXL.Cells(rownum, colnum).Text
'        Next colnum
'    Next rownum
'    'make array the correct size to hold only existing data
''    frmProgress.lblStatus.Caption = "Workbook Data Input Completed"
''    frmProgress.Refresh
'    DoEvents
'    ReDim Preserve WorksheetData(1 To 21, 1 To entrycounter)
'    ReadExcelDataIntoArray = True
'    DoEvents
'    '
'cleanup:
''    frmProgress.lblStatus.Caption = "Please Wait - Closing Excel"
''    frmProgress.Refresh
'    DoEvents
'    objXL.Quit                      'close Excel version that we ran
'    Set wsXL = Nothing              'destroy worksheet object
'    Set wbXL = Nothing              'destroy workbook object
'    Set objXL = Nothing             'destroy excel application object
''    Unload frmProgress
''    Set frmProgress = Nothing
'    Screen.MousePointer = vbDefault
'    Exit Function
'    '
'ReadExcelDataIntoArrayErr:
'    Screen.MousePointer = vbDefault
''    Unload frmProgress
''        Set frmProgress = Nothing
'    errhandler "ReadExcelDataIntoArray", Err.Number, Err.Description
'    ReadExcelDataIntoArray = False
'    Resume cleanup
'End Function

'Public Sub SaveGridToExcel()
'    On Error GoTo SaveGridToExcelErr
'    Dim AllOutputResults() As String
'    Dim linedata() As String
'    Dim n As Long, currentheight As Single
'    '-----------------------------------------------
'    'see if Excel is installed on local machine
'    '-----------------------------------------------
'    If Not ExcelInstalled Then
'        'Excel Is Not Installed
'        MsgBox "Excel is not installed on this computer." & vbCrLf & vbCrLf & _
'               "This function will not work without a valid Microsoft Excel Installation.", vbOKOnly, "Excel Not Installed"
'        Exit Sub
'    End If
'    '-----------------------------------------------
'    'Excel Is Installed
'    '-----------------------------------------------
'    'variables for excel
'    Dim objXL       As Excel.Application
'    Dim wbXL        As Excel.Workbook
'    Dim wsXL        As Excel.Worksheet
'    Dim rownum As Long, colnum As Long, DateString As String, pos As Long
'    '------------------------------------------------
'    'if user doesn't have Excel installed, exit
'    '------------------------------------------------
'    'perform one more test to make sure there's no weird OS/Office version conflict
'    If Not IsObject(objXL) Then
'        MsgBox "You need to have Microsoft Excel installed to use this function", vbExclamation, "Excel does not appear to be Installed"
'        Exit Sub
'    End If
'    '------------------------------------------------
'    'open Excel
'    '------------------------------------------------
'    Screen.MousePointer = vbHourglass
'    Set objXL = New Excel.Application
'    DoEvents
'    objXL.Visible = False
'    Set wbXL = objXL.Workbooks.Add
'    DoEvents
'    Set wsXL = objXL.ActiveSheet
'    DoEvents
'    '------------------------------------------------
'    'get data from string into array
'    '------------------------------------------------
'    AllOutputResults() = Split(OutputResults, vbCrLf)
'    '------------------------------------------------
'    'assign name worksheet, include date
'    '------------------------------------------------
'    DateString = Format$(Date$, "mm_dd_yyyy")
'    wsXL.Name = "SmokeDog_Keywords_" & DateString
'    '    '------------------------------------------------
'    '    'label worksheet columns
'    '    '------------------------------------------------
'    '    'Keyword, Allinanchor, Zone, Count, Months, Difficulty, Links Per Month
'    '    wsXL.Cells(1, 1).Value = "Keyword"
'    '    wsXL.Cells(1, 2).Value = "Allinanchor"
'    '    wsXL.Cells(1, 3).Value = "Zone"
'    '    wsXL.Cells(1, 4).Value = "Count"
'    '    wsXL.Cells(1, 5).Value = "Months"
'    '    wsXL.Cells(1, 6).Value = "Difficulty"
'    '    wsXL.Cells(1, 7).Value = "Links Per Month"
'    DoEvents
'    '------------------------------------------------
'    'insert array contents into worksheet
'    '------------------------------------------------
'    For rownum = LBound(AllOutputResults) To UBound(AllOutputResults)
'        'get all cols from each row into array
'        linedata() = Split(AllOutputResults(rownum), ",")
'        'loop through every column
'        For colnum = LBound(linedata) To UBound(linedata)
'            wsXL.Cells(rownum + 1, colnum + 1).value = linedata(colnum) & " "
'            If colnum = 2 Then
'                'examine zone, set cell color according to zone
'                Select Case Trim$(linedata(2))
'                    Case "1"
'                        wsXL.Cells(rownum + 1, colnum + 1).Interior.Color = RGB(204, 255, 204)  'Light Green
'                    Case "2"
'                        wsXL.Cells(rownum + 1, colnum + 1).Interior.Color = RGB(0, 255, 0)      'Bright Green
'                    Case "3"
'                        wsXL.Cells(rownum + 1, colnum + 1).Interior.Color = RGB(255, 255, 0)    'Yellow
'                    Case "4"
'                        wsXL.Cells(rownum + 1, colnum + 1).Interior.Color = RGB(255, 0, 0)      'Red
'                End Select
'            End If
'            'autofit the column width for this entry
'            wsXL.Columns(colnum + 1).AutoFit
'            'change top row color and font
'            If n = LBound(linedata) Then
'                'change the top row font to bold
'                objXL.Application.ActiveCell.EntireRow.Font.Bold = True
'                'change the top row background color to sky blue
'                For n = 1 To 7
'                    wsXL.Cells(1, n).Interior.Color = RGB(0, 204, 255) 'sky blue
'                Next
'                wsXL.Rows(1).RowHeight = wsXL.Rows(1).RowHeight * 2
'            End If
'        Next
'    Next
'    DoEvents
'    '
'cleanup:
'    objXL.Visible = True
'    DoEvents
'    Set wbXL = Nothing
'    Set wsXL = Nothing
'    Set objXL = Nothing
'    Screen.MousePointer = vbDefault
'    Exit Sub
'    '
'SaveGridToExcelErr:
'    Screen.MousePointer = vbDefault
'    ErrHandler "SaveGridToExcel", Err.Number, Err.Description
'    Resume cleanup
'End Sub

Public Sub Demo()
    Dim ApExcel As Object
    Set ApExcel = CreateObject("Excel.application") 'Creates an object
    ApExcel.Visible = True                          'So you can see Excel
    ApExcel.Workbooks.add                           'Adds a new book.
    ApExcel.Cells(1, 1).Formula = "HELLO"           'Add Text to a Cell
    'You can use the line above, changing coordenates to go to any
    'cell and you can also add Formulas
    ApExcel.Range("A1:Z1").Borders.Color = RGB(0, 0, 0) 'Use it to change the borders.
    ApExcel.Columns("A:AY").EntireColumn.AutoFit        'To adjust the column's width.
    ApExcel.Range("A:Z").Select                         'To establish a selection
    ApExcel.Selection.NumberFormat = "0"                'Adding different formats
End Sub

Public Sub OpenExistingWorkbook()
    Dim oXLApp As Excel.Application     'Declare the object variables
    Dim oXLBook As Excel.Workbook
    Set oXLApp = New Excel.Application  'Create a new instance of Excel
    'Add a new empty workbook
    'Set oXLBook = oXLApp.Workbooks.Add
    'Open an existing workbook
    Set oXLBook = oXLApp.Workbooks.Open("c:\my folder\my workbook.xls")
    oXLApp.Visible = True               'Show it to the user
    Set oXLBook = Nothing               'Disconnect from Excel (let the user take over)
    Set oXLApp = Nothing                'free up resources
End Sub

Public Sub TextExcelData()
    On Error GoTo TextExcelDataErr
    'test excel data in array for validity, let user correct incorrect entries
    'data will be updated in Excel file before program is closed
    
    
    Exit Sub
    '
TextExcelDataErr:
    errhandler "Sub TextExcelData", Err.Number, Err.Description
End Sub
