Attribute VB_Name = "modNonSymmetrical"
Option Explicit

'http://en.wikibooks.org/wiki/Visual_Basic/Simple_Arithmetic

'Public Const pi             As Double = 3.14159265358979
Public Const c              As Double = 299792456#          'meters per second
Public Const crad           As Double = 57.29578

Public freq                 As Double
Public wavelength           As Double
Public large_diameter       As Double
Public small_diameter       As Double
Public odepth               As Double
Public odepth_position      As Double
Public tilt_angle           As Double
Public est_tilt_angle       As Double
Public focal_length         As Double
Public equiv_f_over_D       As Double
'Public f_over_D             As Double
Public small_feedangle      As Double
Public small_feedang_deg    As Double
Public large_feedangle      As Double
Public large_feedang_deg    As Double
Public R_edge               As Double
Public R_aim                As Double
Public space_attn           As Double
Public desired_taper        As Double
Public BW3                  As Double
Public simple_horn_diameter As Double
Public dish_gain            As Double
Public xb                   As Double
Public yb                   As Double
Public xd                   As Double
Public yd                   As Double
Public xt                   As Double
Public yt                   As Double
Public Den                  As Double
Public D1                   As Double
Public D2                   As Double
Public tilt_inc             As Double
Public bottom_angle         As Double
Public bottom_string        As Double
Public top_angle            As Double
Public top_string           As Double
Public aim_angle            As Double
Public xbot                 As Double
Public ybot                 As Double
Public xtop                 As Double
Public ytop                 As Double
Public xcalc                As Double
Public error                As Double
Public min_f                As Double
Public min_tilt_angle       As Double
Public x_offset             As Double
Public y_offset             As Double
Public min_y_offset         As Double
Public min_error            As Double
Public metric               As Double
Public fod                  As Double
Public H_aperture           As Double
Public E_aperture           As Double
Public axial_length         As Double
Public efficiency           As Double
Public radius               As Double
Public aperture             As Double

Public units                As String
Public unit_type            As String
Public s1                   As String

'Arcsin(x) = Atn( x / Sqr(-x * x + 1))
'Arccos(x) = Atn(-x / Sqr(-x * x + 1)) + 2 * Atn(1)

'Public Function Arcsin(xarg As Double) As Double
'    Arcsin = atan2(xarg, Sqr(1 - xarg * xarg))
'End Function

'Public Function Arcsin(xarg As Double) As Double
'    Arcsin = Atn(xarg / Sqr(1 - xarg * xarg))
'End Function

'Public Function Arcsin(xarg As Double) As Double
'    Arcsin = Atn(xarg / Sqr(-xarg * xarg + 1))
'End Function

Function ArcSin(value As Double) As Double
    'http://www.xtremevbtalk.com/showthread.php?t=221769
    ' error if value is outside the range [-1,1]
    If Abs(value) <> 1 Then
        ArcSin = Atn(value / Sqr(1 - value * value))
    Else
        ArcSin = 1.5707963267949 * Sgn(value)
    End If
End Function

Public Function Arccos(xarg As Double) As Double
    Arccos = Atn(-xarg / Sqr(-xarg * xarg + 1)) + 2 * Atn(1)
End Function

'Public Function atan2(ByVal y As Double, ByVal x As Double) As Double
'    If y > 0 Then
'        If x >= y Then
'            atan2 = Atn(y / x)
'        ElseIf x <= -y Then
'            atan2 = Atn(y / x) + pi
'        Else
'            atan2 = pi / 2 - Atn(x / y)
'        End If
'    Else
'        If x >= -y Then
'            atan2 = Atn(y / x)
'        ElseIf x <= y Then
'            atan2 = Atn(y / x) - pi
'        Else
'            atan2 = -Atn(x / y) - pi / 2
'        End If
'    End If
' End Function


Public Function Atan2(y As Double, x As Double) As Double
    'http://forums.devx.com/showthread.php?t=69063
    If x > 0 Then
        Atan2 = Atn(y / x)
    ElseIf x < 0 Then
        Atan2 = Sgn(y) * (pi - Atn(Abs(y / x)))
    ElseIf y = 0 Then
        Atan2 = 0
    Else
        Atan2 = Sgn(y) * pi / 2
    End If
End Function
 
 Public Function Rotate_point(xa As Double, ya As Double, angle As Double, ByRef xr As Double, ByRef yr As Double)
    xr = ya * Cos(angle) - xa * Sin(angle)
    yr = ya * Sin(angle) + xa * Cos(angle)
 End Function


' convert from degrees to radians

Public Function DegreesToRadians(ByVal degrees As Single) As Single
    DegreesToRadians = degrees / 57.29578
End Function

' convert from radians to degrees

Public Function RadiansToDegrees(ByVal radians As Single) As Single
    RadiansToDegrees = radians * 57.29578
End Function

Public Function ArcTangent(ByVal op As Double, ByVal ad As Double) As Double
    Const pi = 3.14159265358979
    Dim at As Double
    If ad = 0 Then
        If op > 0 Then
            ArcTangent = pi / 2#
        Else
            ArcTangent = pi * 1.5
        End If
    Else
        at = Atn(op / ad)
        If ad < 0 Then
            ArcTangent = pi + at
        ElseIf op# < 0 Then
            ArcTangent = pi + pi + at
        Else
            ArcTangent = at
        End If
    End If
End Function

Public Function Log10(x)
   Log10 = Log(x) / Log(10#)
End Function
